var console = process.console;
var config = require('./config.js');
var redisClient, io, requestify;
var start = false;

module.exports.init = function(redis, ioSocket, requestifyCore) {
    io = ioSocket;
    redisClient = redis.createClient();
    requestify = requestifyCore;
	setTimeout(rediSubscribe, 1000);
}

function rediSubscribe() {
	getCurrentGame();
	redisClient.subscribe('nbdouble');
	redisClient.setMaxListeners(0);
	redisClient.on("message", function (channel, message) {
		if (channel == 'nbdouble') {
			if (!timerStatus && !sliderStatus) getCurrentGame();
			io.sockets.emit(channel, message);
		}
	});
}

var timer,
	ngtimer,
    timerStatus = false,
	sliderStatus = false,
    timerTime = 35,
	sliderTime = 20,
    preFinishingTime = 2;
	
var preFinish = false;

function getCurrentGame() {
    requestify.post('http://' + config.domain + '/api/double/getCurrentGame', {
        secretKey: config.secretKey
    }).then(function (response) {
		game = JSON.parse(response.body);
		console.tag('Double').log('Текущая игра #' + game.id);
		if (game.status != 0) { 
			if (game.status != 3) { 
				startTimer();
			} else {
				newGame();
			}
		}
	}, function (response) {
		console.tag('Игра').log('Ошибка [getCurrentGame]');
		setTimeout(getCurrentGame, 1000);
	});
}
	
function startTimer() {
    var time = timerTime;
    timerStatus = true;
    clearInterval(timer);
    console.tag('Double').log('Новая игра.');
    timer = setInterval(function () {
        io.sockets.emit('dbtimer', time--);
        if ((game.status == 1) && (time <= preFinishingTime)) {
            if (!preFinish) {
                preFinish = true;
                setGameStatus(2);
            }
        }
        if (time <= 0) {
            clearInterval(timer);
            timerStatus = false;
			sliderStatus = true;
            console.tag('Double').log('Конец игры.');
            showSliderWinners();
        }
    }, 1000);
}

function setGameStatus(status) {
    requestify.post('http://' + config.domain + '/api/double/setGameStatus', {
        status: status,
        secretKey: config.secretKey
    }).then(function (response) {
		game = JSON.parse(response.body);
		console.tag('Double').log('Статус игры: ' + status);
	}, function (response) {
		console.tag('Double').error('Something wrong [setGameStatus]');
		setTimeout(setGameStatus, 1000);
	});
}

function showSliderWinners() {
    requestify.post('http://' + config.domain + '/api/double/startGame', {
        secretKey: config.secretKey
    }).then(function (response) {
		var winners = response.body;
		console.tag('Double').log('Показываем слайдер!');
		setGameStatus(3);
		var time = sliderTime;
		var data = JSON.parse(winners);
		data.showSlider = true;
		clearInterval(ngtimer);
		console.tag('Double').log('Отсчет пошел');
		ngtimer = setInterval(function () {
			time--;
			if (time <= 10) data.showSlider = false;
			io.sockets.emit('doubleslider', data);
			if (time <= 0) {
				clearInterval(ngtimer);
				newGame();
				console.tag('Игра').log('Отсчет окончен');
				sliderStatus = false;
			}
		}, 1000);
	}, function (response) {
		console.tag('Double').error('Something wrong [showSlider]');
		setTimeout(showSliderWinners, 1000);
	});
}

function newGame() {
    requestify.post('http://' + config.domain + '/api/double/newGame', {
        secretKey: config.secretKey
    }).then(function (response) {
		var data = JSON.parse(response.body);
		preFinish = false;
		console.tag('Double').log('Новая игра! #' + data.id);
		game = data;
		io.sockets.emit('ngdouble', data.id);
	}, function (response) {
		console.tag('Double').error('Something wrong [newGame]');
		setTimeout(newGame, 1000);
	});
}

//getCurrentGame();