<?php

namespace App\Http\Controllers;

use App\Game;
use App\Shop;
use App\User;
use App\Item;
use App\Bet;
use Firebase\Firebase;
use App\Services\BackPack;
use App\Services\CsgoFast;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;

use Carbon\Carbon;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use PhpParser\Node\Expr\Cast\Object_;

class AjaxController extends Controller
{
	public function chat(Request $request) {
        $type = $request->get('type');
        if(!$request->has('type')) {
            return response()->json(['success' => false, 'text' => 'Тип запроса не указан']);
        }
        if($type == 'push') {
			$now = Carbon::now();
            if ($this->user->banchat >= $now) {
                return response()->json(['success' => false, 'text' => 'Вы не можете отправлять сообщения, так как забанены до '.$this->user->banchat]);
            }
            $censure = array('залупа', 'подкрутка','.ru', '.com','.net','. net', '.top','. ru', 'ru', '.in', '. com', 'заходи', 'классный сайт', 'го на');
			$censure1 = array('/admin');
            $message = $request->get('message');
            if(is_null($message)) {
                return response()->json(['success' => false, 'text' => 'Вы не ввели сообщение']);
            }
            if(strlen($message) == 0) {
                return response()->json(['success' => false, 'text' => 'Вы не ввели сообщение']);
            }
            if(strlen($message) > 200) {
                return response()->json(['success' => false, 'text' => 'Максимум 200 символов']);
            }
            if (Session::has('last_chat_message') && Session::get('last_chat_message')+1>time()) {
                return response()->json(['success' => false, 'text' => '1 сообщение в секунду']);
            }
            $gamesCount = Bet::where('user_id', $this->user->id)->count();
            if($gamesCount < 1 && !$this->user->is_admin) {
                return response()->json(['success' => false, 'text' => 'Вы должны сделать хотя бы 1 ставку на сайте!']);
            }
			$message1 = substr_count($message,'/admin');
			$moderator = $this->user->is_moderator;
			if ($moderator = 1){
			if ($message1 >= 1) {
				 $moderator = $this->user->is_moderator;
				 $message = str_replace($censure1, '', $message);
				} else {
            $moderator = 0;
		}} else{
			 $message = str_replace($censure, '***', $message);
		}
            $push = array(
                'username' => $this->user->username,
                'avatar' => $this->user->avatar,
                'steamid' => $this->user->steamid64,
                'is_admin' => $this->user->is_admin,
                'is_moderator' => $this->user->is_moderator,
                'message' => $message
            );
            $this->redis->publish('chat_new_message', json_encode([
                'username' => $this->user->username,
                'text' => $message,
                'avatar' => $this->user->avatar,
				'is_moderator' => $moderator,
                'steamid' => $this->user->steamid64
            ]));
            Session::set('last_chat_message',time());
            return response()->json(['success' => true, 'text' => 'Сообщение добавлено']);
        }
        if($type == 'remove') {
            if(!$this->user->is_moderator && !$this->user->is_admin) {
                return response()->json(['success' => false, 'text' => 'Вам недоступная данная функция!']);
            }
            $id = $request->get('id');
            $this->redis->publish('chat_remove_message', json_encode([
                'id' => $id
            ]));
            return response()->json(['success' => true, 'text' => 'Сообщение удалено']);
        }
        if ($type == 'ban') {
            if(!$this->user->is_moderator && !$this->user->is_admin) {
                return response()->json(['success' => false, 'text' => 'Вам недоступная данная функция!']);
            }
            $steamid = $request->get('steamid');
            $time = $request->get('time');
            if ($time == -1)
                $time = 60*24*365*10;
            $banTime = Carbon::now()->addMinutes($time);
            $user = User::where('steamid64',$steamid)->first();
            if ($user) {
                $user->banchat = $banTime;
                $user->save();
                $this->redis->publish('chat_ban', json_encode([
                    'steamid' => $steamid,
                    'bantime' => $banTime->format('d.m.Y G:i T')
                ]));
            return response()->json(['success' => true, 'text' => 'Пользователь забанен в чате на '.$time.' минут']);
            }
        }
    }
    
}
