<?php

namespace App\Http\Controllers;
use App\Game;
use App\CrashGame;
use App\Bet;
use App\Item;
use App\Services\SteamItem;
use App\Ticket;
use App\User;
use Carbon\Carbon;
use Config;
use Illuminate\Http\Request;
use App\WinnerTicket;
use Illuminate\Support\Str;
use Illuminate\Console\Command;
use Symfony\Component\Console\Input\InputOption;

use App\Http\Requests;
use App\Http\Controllers\Controller;

use Storage;
use Db;

class GameController extends Controller
{
       const SECRET_KEY    = 'eK2qpgqnp';
    const BOT_TRADE_LINK = 'https://steamcommunity.com/tradeoffer/new/?partner=332747380&token=9C1C52MS'; # Трейд ссылка
	const FAST_TRADE_LINK = 'https://steamcommunity.com/tradeoffer/new/?partner=55264111&token=ig9fD-FL'; # Трейд ссылка фаста
	const SHOP_TRADE_LINK = 'https://steamcommunity.com/tradeoffer/new/?partner=197743783&token=rv48iPav'; # Трейд ссылка магазина
   const MIN_PRICE = 1;             # Минимальная ставка
    const MAX_ITEMS = 20;                   # Максимальное кол-во предметов в ставке
    const COMMISSION = 12;                   # Комиссия
	const SITENAME = 'SHOWLUCKY.RU';                   # Комиссия
    const COMMISSION_FOR_FIRST_PLAYER = 1;   # Скидка для первого игрока сделавшего ставку.
	const COMMISSION_FOR_NICK_PLAYER = 2;   # Скидка для игрока с сайтом в нике.
	const COMMISSION_ON = 1;                   # 0 - комиссия со всей игры, 1 - с выигрыша.
	const NEXTBET_ON = 0;                   # 0 - выключить автоставку, 1 - включить автоставку.
	const SENDSHOP_ON = 0;               # 0 - выключить откравку комиссии магазину, 1 - включить отправку.
	const SHOPSTEAMID64 = 76561198074785807; # SteamID64 От аккаута магазина. (он должен быть авторизирован на сайте)!
    const APPID = 730;                  # AppID игры: 570 - Dota2, 730 - CS:GO

    const URL_REQUEST = 'http://backpack.tf/api/IGetMarketPrices/v1/?key=';
    const API_KEY = '57507d6683de6b32c04b0f1b'; # Ключ для сайта backpack.tf

	const GDonateKeyPublic = '5dcc2-2372';
    const GDonateKey = 'ef05736abff44d76e0dc307a49571d95';
	
    const SEND_OFFERS_LIST = 'send.offers.list';
    const NEW_BET_CHANNEL = 'newDeposit';
    const BET_DECLINE_CHANNEL = 'depositDecline';
    const INFO_CHANNEL = 'msgChannel';
    const SHOW_WINNERS = 'show.winners';
    public $comission;
    public $game;
    public $bots = ['3', '4', '5', '6','7'];
    public $items = [

        [
            'name' => 'Glock-18 | Водяной (После полевых)',
            'market_hash_name' => 'Glock-18 | Water Elemental (Field-Tested)',
            'classid' => '1649974083',
            'rarity' => 'classified',
            'price' => '227.14'
        ],
        [
            'name' => 'M4A1-S | Атомный сплав (Немного поношенное)',
            'market_hash_name' => 'M4A1-S | Atomic Alloy (Minimal Wear)',
            'classid' => '1654837488',
            'rarity' => 'classified',
            'price' => '375.87'
        ],
        [
            'name' => 'P90 | Азимов (После полевых)',
            'market_hash_name' => 'P90 | Asiimov (Field-Tested)',
            'classid' => '1654821735',
            'rarity' => 'covert',
            'price' => '365.82'
        ],
                [
            'name' => 'AK-47 | Красная линия (После полевых)',
            'market_hash_name' => 'AK-47 | Redline (Field-Tested)',
            'classid' => '1633545916',
            'rarity' => 'classified',
            'price' => '355.12'
        ],
		 [
            'name' => 'AWP | Электрический улей (После полевых)',
            'market_hash_name' => 'AWP | Электрический улей (Field-Tested)',
            'classid' => '1969753751',
            'rarity' => 'classified',
            'price' => '518.49'
        ]
    ];
    protected $lastTicket = 0;

    private static $chances_cache = [];

    public function __construct()
    {
        parent::__construct();
        $this->game = $this->getLastGame();
        $this->lastTicket = $this->redis->get('last.ticket');
    }

    public function deposit()
    {
        return redirect(self::BOT_TRADE_LINK);
    }
public function betfast()
    {
        return redirect(self::FAST_TRADE_LINK);
    }
	 public function addbalance()
    {
        return redirect(self::SHOP_TRADE_LINK);
    }

public function newBetFake($steamid) {
        $user = User::where('steamid64', $steamid)->first();
        if(is_null($user)) return false;

        $rand = array_rand($this->items);
        $items = $this->items[$rand];

         $lastBet1 = Bet::where('game_id', $this->game->id)->orderBy('to', 'desc')->first();
            $ticketFrom = 1;
            $ticketTo = round($items['price'] * 1);
             if (!is_null($lastBet1)) {
                $ticketFrom = $lastBet1->to + 1;
                $ticketTo = $ticketFrom + ($items['price'] * 1);
            }
        $lastBet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
			if ($lastBet->user_id != $items['price'] || $lastBet->game_id != $this->game->id) {
				$bet = new Bet();
				$bet->user()->associate($user);
				$bet->items = json_encode([$items]);
				$bet->itemsCount = 1;
				$bet->price = $items['price'];
				$bet->from = $ticketFrom;
				$bet->to = $ticketTo;
				$bet->game()->associate($this->game);
				$bet->save();
			} else {
				$items = [];
				$lastBetItems = json_decode($lastBet->items);
				foreach ($lastBetItems as $i){
					$items[] = $i;
				}
				foreach ($items['items'] as $i){
					$items[] = $i;
				}
				$newprice = $lastBet->price + $items['price'];
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['items' => json_encode([$items])]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['itemsCount' => $lastBet->itemsCount + 1]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['price' => $lastBet->price + $items['price']]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['to' => $ticketTo]);
				$bet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
				
			}
			
            $bets = Bet::where('game_id', $this->game->id);
            $this->game->items = $bets->sum('itemsCount');
            $this->game->price = $bets->sum('price');

            if (count($this->game->users()) >= 2 || $this->game->items >= 100) {
                $this->game->status = Game::STATUS_PLAYING;
                $this->game->started_at = Carbon::now();
            }

            if ($this->game->items >= 100) {
                $this->game->status = Game::STATUS_FINISHED;
                $this->redis->publish(self::SHOW_WINNERS, true);
            }

            $this->game->save();
			$bettemp = $bet;
			$html = '';
			$htmladmin = '';
			$lastbets = \DB::table('bets')->where('game_id', $this->game->id)->orderBy('id')->get();
			foreach ($lastbets as $lastbet) {
				$lastuser =  \DB::table('users')->where('id', $lastbet->user_id)->first();
				$bet = $lastbet;
				$bet->user = $lastuser;
				$bet->game = $this->game;
				
				$html = view('includes.bet', compact('bet'))->render().$html;
				$htmladmin = view('includes.betadmin', compact('bet'))->render().$htmladmin;
			}
			$bet = $bettemp;
            $chances = $this->_getChancesOfGame($this->game);
			$gameid = \DB::table('games')->max('id'); 
$tec = \DB::table('winner_tickets')->max('game_id'); 
$from = $ticketFrom; 
$to = $ticketTo; 
$ticket = mt_rand($from, $to);
if($tec ==$gameid){ 
\DB::table('winner_tickets')->where('game_id', '=', $gameid)->update(['winnerticket' => $ticket]);} 
else { 
\DB::table('winner_tickets')->insertGetId( 
['winnerticket' => $ticket, 'game_id' => $gameid]); 
} 
            $returnValue = [
                'betId' => $bet->id,
                'userId' => $user->steam64,
                'html' => $html,
				'htmladmin' => $htmladmin,
                'itemsCount' => $this->game->items,
                'gamePrice' => $this->game->price,
                'gameStatus' => $this->game->status,
                'chances' => $chances
            ];
            $this->redis->publish(self::NEW_BET_CHANNEL, json_encode($returnValue));
        return true;
    }
    public function currentGame()
    {
        $game = Game::orderBy('id', 'desc')->first();
        $bets = $game->bets()->with(['user', 'game'])->get()->sortByDesc('created_at');
        $user_chance = $this->_getUserChanceOfGame($this->user, $game);
        $chances = $this->_getChancesOfGame($game, true);
        if (!is_null($this->user)) $user_items = $this->user->itemsCountByGame($game);

        return view('pages.index', compact('trp','tgp','tbp','bankd','game', 'bets', 'user_chance', 'chances', 'user_items','gamecrash'));
    }

    public function getLastGame()
    {
        $game = Game::orderBy('id', 'desc')->first();
        if (is_null($game)) $game = $this->newGame();
        return $game;
    }

    public function getCurrentGame()
    {
        $this->game->winner;
        return $this->game;
    }
	public function getClassic()
    {
		$gameid = \DB::table('double_games')->max('id');
		$gamecrash = DB::table('crashgames')->where('id', \DB::table('crashgames')->max('id'))->pluck('price');

		$trp = 0;
		$tr = \DB::table('double_bets')->where('type', 1)->where('game_id', $gameid)->get();
		foreach ($tr as $i){
			$trp += $i->price;
		}
		$tgp = 0;
		$tg = \DB::table('double_bets')->where('type', 2)->where('game_id', $gameid)->get();
		foreach ($tg as $i){
			$tgp += $i->price;
		}
		$tbp = 0;
		$tb = \DB::table('double_bets')->where('type', 3)->where('game_id', $gameid)->get();
		foreach ($tb as $i){
			$tbp += $i->price;
		}
		$bankd= $trp+$tgp+$tbp;
		$bets  = $this->game->bets()->with(['user', 'game'])->orderBy('id', 'desc')->get();
		foreach($bets as $i){
	    $i->price = $i->price;
		$i->from = $i->from;
		$i->to = $i->to;
		$i->user = User::Find($i->user_id);
		$i->items = json_decode($i->items,true);
		$i->chance = $this->_getUserChanceOfGame($i->user, $i->game);		
	}
		if($this->user){
		$returnValue = [
		    'user'   => 1,
            'game'   => $this->game->id,
			'hash'   => md5($this->game->rand_number),
            'price' => $this->game->price,
			'pricec' => $gamecrash,
			'priced' => $bankd,
            'items' => $this->game->items,
			'status' => $this->game->status,
			'chance' => $this->_getUserChanceOfGame($this->user, $this->game),
			'user_items' => $this->user->itemsCountByGame($this->game),
			'chances' => $this->_getChancesOfGame($this->game, true),
			'bets' => $bets
        ];
 }else{
      $returnValue = [
		    'user'   => 0,
            'game'   => $this->game->id,
			'hash'   => md5($this->game->rand_number),
            'price' => $this->game->price,
			'pricec' => $gamecrash,
			'priced' => $bankd,
            'items' => $this->game->items,
			'status' => $this->game->status,
			'chances' => $this->_getChancesOfGame($this->game, true),
			'bets' => $bets
        ];
 }

        return response()->json($returnValue);
    }
	public function getCrash()
    {
		$game = CrashGame::orderBy('id', 'desc')->first();
		$games = CrashGame::Where('status',CrashGame::STATUS_FINISHED)->orderBy('id', 'desc')->take(8)->get();
		foreach($games as $i){
	    $i->number = $i->number;
		$i->rand_number = $i->rand_number;
		$i->hash = md5(''.$i->rand_number.''.$i->number.'');
		$i->id = $i->id;
	}
		if($game->status == CrashGame::STATUS_FINISHED){
			$bets = \DB::table('crashbets')->where('crash_game_id', $game->id+1)->orderBy('id','DESC')->get();
		}else{
			$bets = \DB::table('crashbets')->where('crash_game_id', $game->id)->orderBy('id','DESC')->get();
		}
		$gameid = \DB::table('double_games')->max('id');

		$trp = 0;
		$tr = \DB::table('double_bets')->where('type', 1)->where('game_id', $gameid)->get();
		foreach ($tr as $i){
			$trp += $i->price;
		}
		$tgp = 0;
		$tg = \DB::table('double_bets')->where('type', 2)->where('game_id', $gameid)->get();
		foreach ($tg as $i){
			$tgp += $i->price;
		}
		$tbp = 0;
		$tb = \DB::table('double_bets')->where('type', 3)->where('game_id', $gameid)->get();
		foreach ($tb as $i){
			$tbp += $i->price;
		}
		$bankd= $trp+$tgp+$tbp;
		$bets  = $game->bets()->with(['user', 'game'])->orderBy('id', 'desc')->get();
		foreach($bets as $i){
	    $i->number = $i->number;
		$i->price = $i->price;
		$i->username = User::getUserInfo($i->user_id)->username;
		$i->avatar = User::getUserInfo($i->user_id)->avatar;
		$i->steamid64 = User::getUserInfo($i->user_id)->steamid64;	
	}
		if($this->user){
		$returnValue = [
		    'user'   => 1,
            'game'   => $game->id,
			'hash'   => md5(''.$game->rand_number.''.$game->number.''),
            'price' => $this->game->price,
			'pricec' => $game->price,
			'priced' => $bankd,
			'games' => $games,
			'bets' => $bets
        ];
 }else{
      $returnValue = [
		    'user'   => 0,
            'game'   => $game->id,
			'hash'   => md5(''.$game->rand_number.''.$game->number.''),
            'price' => $this->game->price,
			'pricec' => $game->price,
			'priced' => $bankd,
			'games' => $games,
			'bets' => $bets
        ];
 }

        return response()->json($returnValue);
    }
	public function getDouble()
    {
		$gameid = \DB::table('double_games')->max('id');
		$gamecrash = DB::table('crashgames')->where('id', \DB::table('crashgames')->max('id'))->pluck('price');
		$games = \DB::table('double_games')->orderBy('id')->where('id','>=', $gameid-5)->where('id','<', $gameid)->get();
		foreach ($games as $i){
			$i->type = $this->_getWinnerType($i->num);
		}
		$trp = 0;
		$tr = \DB::table('double_bets')->where('type', 1)->where('game_id', $gameid)->get();
		foreach ($tr as $i){
			$trp += $i->price;
		}
		$tgp = 0;
		$tg = \DB::table('double_bets')->where('type', 2)->where('game_id', $gameid)->get();
		foreach ($tg as $i){
			$tgp += $i->price;
		}
		$tbp = 0;
		$tb = \DB::table('double_bets')->where('type', 3)->where('game_id', $gameid)->get();
		foreach ($tb as $i){
			$tbp += $i->price;
		}
		if($this->user){
		$mrp = 0;
		$mr = \DB::table('double_bets')->where('type', 1)->where('user_id', $this->user->id)->where('game_id', $gameid)->get();
		foreach ($mr as $i){
			$mrp += $i->price;
		}
		$mgp = 0;
		$mg = \DB::table('double_bets')->where('type', 2)->where('user_id', $this->user->id)->where('game_id', $gameid)->get();
		foreach ($mg as $i){
			$mgp += $i->price;
		}
		$mbp = 0;
		$mb = \DB::table('double_bets')->where('type', 3)->where('user_id', $this->user->id)->where('game_id', $gameid)->get();
		foreach ($mb as $i){
			$mbp += $i->price;
		}
		}else{
			$mrp = 0;
			$mgp = 0;
			$mbp = 0;
		}
		$users = [];
		$tu = \DB::table('double_bets')->where('game_id', $gameid)/*->groupBy('user_id')*/->get();
		foreach ($tu as $i){
			$user = User::where('id', $i->user_id)->first();
			$users[$i->user_id] = $user;
		}
		$data = [
			'tr'=>$trp,
			'tg'=>$tgp,
			'tb'=>$tbp,
			'mr'=>$mrp,
			'mg'=>$mgp,
			'mb'=>$mbp,
			'rb'=>$trp+$tgp+$tbp
		];
		$am = \DB::table('double_games')->where('id','>=', $gameid-100)->sum('am');
		$bankd= $trp+$tgp+$tbp;
		if($this->user){
		$returnValue = [
		    'user'   => 1,
            'game'   => $gameid,
            'price' => $this->game->price,
			'pricec' => $gamecrash,
			'priced' => $bankd,
			'tr' => $tr,
			'tg' => $tg,
			'tb' => $tb,
            'games' => $games,
			'users' => $users,
			'data' => $data,
			'am' => $am
        ];
 }else{
      $returnValue = [
		    'user'   => 0,
            'game'   => $gameid,
            'price' => $this->game->price,
			'pricec' => $gamecrash,
			'priced' => $bankd,
			'tr' => $tr,
			'tg' => $tg,
			'tb' => $tb,
            'games' => $games,
			'users' => $users,
			'data' => $data,
			'am' => $am
        ];
 }

        return response()->json($returnValue);
    }
	public function _getWinnerType($num){
		if ($num > 0 && $num < 8) $type = 1;
		if ($num == 0) $type = 2;
		if ($num > 7) $type = 3;
        return $type;
    }
	public function _getTypeText($type){
		if ($type == 1) $txt = 'красное';
		if ($type == 2) $txt = 'зеленое';
		if ($type == 3) $txt = 'черное';
        return $txt;
    }
	public function _getTypeColor($type){
		if ($type == 1) $realcolor = '#C9302C';
		if ($type == 2) $realcolor = '#449D44';
		if ($type == 3) $realcolor = '#444444';		
        return $realcolor;
    }
	public function getTop()
    {
      $users = \DB::table('users')
		    ->where('is_admin', 0)
            ->select('users.id',
                'users.username',
                'users.avatar',
                'users.steamid64',
                \DB::raw('SUM(games.price) as top_value'),
                \DB::raw('COUNT(games.id) as wins_count')
            )
            ->join('games', 'games.winner_id', '=', 'users.id')
            ->groupBy('users.id')
            ->orderBy('top_value', 'desc')
            ->limit(20)
            ->get();
        $i = 0;
        foreach($users as $u){
            $users[$i]->games_played = count(\DB::table('games')
                ->join('bets', 'games.id', '=', 'bets.game_id')
                ->where('bets.user_id', $u->id)
                ->groupBy('bets.game_id')
                ->select('bets.id')->get());
            $users[$i]->win_rate = round($users[$i]->wins_count / $users[$i]->games_played, 3) * 100;
            $users[$i]->rang = ($i < 18) ? $i+1 : 18;
			$users[$i]->place = $i;
            $i++;
        }
		$returnValue = [
		    'users'   => $users
        ];
        return response()->json($returnValue);
    }
	public function getGlobal()
    {
        return $this->user;
    }
	public function getRef()
    {
		$tickets = \DB::table('ref_list')->where('ref_id',$this->user->steamid64)->orderBy('id')->get();
        return $tickets;
    }
	public function getHistory()
    {
      $games = Game::with(['bets', 'winner'])
            ->where('status', Game::STATUS_FINISHED)
            ->orderBy('created_at', 'desc')
            ->limit(10)
            ->get();
 
        foreach($games as $key => $game) {
            $items = array();
            $price = array();
            foreach($game->bets as $bet) {
                foreach(json_decode($bet->items) as $item) {
                    $items[] = (array)$item;
                    $price[] = (array)$item->price;
                }
            }
            array_multisort($price, SORT_DESC, $items);
			$items = json_encode($items);
            $games[$key]->game_items = json_decode($items,true);
           $games[$key]->chances = $this->_getChancesOfGame($game, true);
        }

        return $games;
    }
    public function getMywins()
    {
      $games = Game::with(['bets', 'winner'])
            ->where('status', Game::STATUS_FINISHED)
            ->where('games.winner_id', $this->user->id)
            ->orderBy('created_at', 'desc')
            ->limit(10)
            ->get();
 
        foreach($games as $key => $game) {
            $items = array();
            $price = array();
            foreach($game->bets as $bet) {
                foreach(json_decode($bet->items) as $item) {
                    $items[] = (array)$item;
                    $price[] = (array)$item->price;
                }
            }
            array_multisort($price, SORT_DESC, $items);
			$items = json_encode($items);
            $games[$key]->game_items = json_decode($items,true);
           $games[$key]->chances = $this->_getChancesOfGame($game, true);
        }

        return $games;
    }
	public function getMyoffers()
    {
      $items = \DB::table('deposits')->where('userid', $this->user->steamid64)->orderBy('id', 'desc')->get();
        return $items;
    }
	public function getWinners()
    {
        $us = $this->game->users();

        $lastBet = Bet::where('game_id', $this->game->id)->orderBy('to', 'desc')->first();
        $winTicket = WinnerTicket::where('game_id', $this->game->id)->first();
        if($winTicket==null) {
            $winTicket = round($this->game->rand_number * $lastBet->to);
        } else {
            $winTicket = $winTicket->winnerticket;
            $this->game->rand_number = $winTicket/$lastBet->to;
			
            if(strlen($this->game->rand_number)<20) {
                $diff = 20 - strlen($this->game->rand_number);
                $min = "1";
                $max = "9";
                for($i = 1; $i < $diff; $i++) {
                    $min .= "0";
                    $max .= "9";
                }
                $this->game->rand_number = $this->game->rand_number."".  rand($min, $max);
            }
        }

        $winningBet = Bet::where('game_id', $this->game->id)->where('from', '<=', $winTicket)->where('to', '>=', $winTicket)->first();
        $this->game->winner_id      = $winningBet->user_id;
        $this->game->status         = Game::STATUS_FINISHED;
		$this->game->chance         = $this->_getUserChanceOfGame($this->game->winner, $this->game);
        $this->game->finished_at    = Carbon::now();
       $adminid = 76561198174898402;
		$admin = User::where('steamid64', $adminid)->first();
		if($this->game->price > 650) {
            $this->game->won_items      = json_encode($this->sendItems($this->game->bets, $admin));
        }else{
			$this->game->won_items      = json_encode($this->sendItems($this->game->bets, $this->game->winner));
		}
		$this->game->comission      = $this->comission;
        $this->game->save();
		
		$users = [];
		foreach ($us as $usr) {
			for($i = 1; $i < round($this->_getUserChanceOfGame($usr, $this->game)); $i++) {
				$users[] = $usr;
			}
		}
		$proverka_koda = DB::table('users')->where('id',$this->game->winner_id)->pluck('ref_activ');
        if($proverka_koda == 1){
        $account_id = $this->game->winner_id;
        $account = DB::table('users')->where('id',$account_id)->pluck('steamid64');
        $ref_count = $this->game->price * 0.01;
        $ref_id = DB::table('ref_list')->where('id_ref',$account)->pluck('ref_id');
        $ref_money = DB::table('users')->where('steamid64',$ref_id)->pluck('money');
        $ref_money1 = $ref_money + $ref_count;
        DB::table('users')->where('steamid64', $ref_id)->update(['money' => $ref_money1]);
        $pribil = DB::table('ref_list')->where('id_ref',$account)->pluck('pribil');
        $pribil1 = $pribil + $ref_count;
        DB::table('ref_list')->where('id_ref', $account)->update(['pribil' => $pribil1]);
        }
		
        $returnValue = [
            'game'   => $this->game,
            'winner' => $this->game->winner,
            'round_number' => $this->game->rand_number,
            'ticket' => $winTicket,
            'tickets' => $lastBet->to,
            'users' => $us,
			'userchanses' => $users,
            'chance' => $this->game->chance
        ];

        return response()->json($returnValue);
    }


    public function sendItems($bets, $user)
    {		
        $itemsInfo = [];
		$itemsInfor = [];
        $items = [];
        $commission = self::COMMISSION;
        $commissionItems = [];
		$nextbetItems = [];
        $returnItems = [];
        $tempPrice = 0;
        $firstBet = Bet::where('game_id', $this->game->id)->orderBy('created_at', 'asc')->first();
        if ($firstBet->user == $user) $commission = $commission - self::COMMISSION_FOR_FIRST_PLAYER;
		$name = strtolower($user->username);
		if (strpos($name,  strtolower(self::SITENAME)) != false) $commission = $commission - self::COMMISSION_FOR_NICK_PLAYER;
        $commissionPrice = round(($this->game->price / 100) * $commission);
		$commissionNextPrice = round(($this->game->price / 100) * self::COMMISSION);
        foreach ($bets as $bet) {
            $betItems = json_decode($bet->items, true);
            foreach ($betItems as $item) {
                //(Отдавать всю ставку игроку обратно)
                if ($bet->user == $user && self::COMMISSION_ON == 1) {
                    $itemsInfo[] = $item;
                    if (isset($item['classid'])) {
                        $returnItems[] = $item['classid'];
                    } else {
                        $user->money = $user->money + $item['price'];
                    }
                } else {
                    $items[] = $item;
                }
            }
        } 
		if (self::NEXTBET_ON == 1) {
			foreach ($items as $item) {
				if ($item['price'] < 1) $item['price'] = 1;
				if (($item['price'] <= $commissionPrice) && ($tempPrice < $commissionPrice)) {
					$commissionItems[] = $item;
					$tempPrice = $tempPrice + $item['price'];
				} else {
					$itemsInfor[] = $item;
				}
			}
			
			$nextbetItemsPrice = 0;
			foreach ($itemsInfor as $item) {
				if (($item['price'] <= $commissionNextPrice) && ($nextbetItemsPrice < $commissionNextPrice)) {
					$nextbetItems[] = $item;
					$nextbetItemsPrice = $nextbetItemsPrice + $item['price'];
				} else {
					$itemsInfo[] = $item;
					if (isset($item['classid'])) {
						$returnItems[] = $item['classid'];
					} else {
						 $user->money = $user->money + ($item['price']*0.9);
					}
				}
			}			
			$returnValue = [
				'offerid' => 0,
				'userid' => $user->id,
				'steamid64' => $user->steamid64,
				'gameid' => $this->game->id,
				'items' => $nextbetItems,
				'price' => $nextbetItemsPrice,
				'success' => true
			];
			if ($nextbetItems != NULL && $nextbetItemsPrice >= 1) {
				$this->redis->rpush('bets.list', json_encode($returnValue)); 
			}
		} else {
			foreach ($items as $item) {
				if ($item['price'] < 1) $item['price'] = 1;
				if (($item['price'] <= $commissionPrice) && ($tempPrice < $commissionPrice)) {
					$commissionItems[] = $item;
					$tempPrice = $tempPrice + $item['price'];
				} else {
					
					$itemsInfo[] = $item;
					if (isset($item['classid'])) {
						$returnItems[] = $item['classid'];
					} else {
						 $user->money = $user->money + $item['price'] - ($item['price']*0.07);
					}
				}
			}
		}
		$this->comission = $tempPrice;
		$user->save();
		$value = [
			'appId' => self::APPID,
			'steamid' => $user->steamid64,
			'accessToken' => $user->accessToken,
			'items' => $returnItems,
			'game' => $this->game->id
		];
		$this->redis->rpush(self::SEND_OFFERS_LIST, json_encode($value));
		
		if (self::SENDSHOP_ON == 1) {
			$shopItems = [];
			foreach ($commissionItems as $item) {
				if (isset($item['classid'])) {
					$shopItems[] = $item['classid'];
				}
			}
			$shop = User::where('steamid64', self::SHOPSTEAMID64)->first();
			if ($shop != NULL) {
				$valueShop = [
					'appId' => self::APPID,
					'steamid' => $shop->steamid64,
					'accessToken' => $shop->accessToken,
					'items' => $shopItems,
					'game' => $this->game->id
				];
				$this->redis->rpush(self::SEND_OFFERS_LIST, json_encode($valueShop));
			}
		}
        return $itemsInfo;
    }

    public function newGame()
    {
        $rand_number = "0." . mt_rand(100000000, 999999999) . mt_rand(100000000, 999999999);
        $game = Game::create(['rand_number' => $rand_number]);
        $game->hash = md5($game->rand_number);
        $game->rand_number = 0;
		$game->users = Game::usersToday();
		$game->games = Game::gamesToday();
		$game->maxwin = Game::maxPrice();
		$game->items = Game::itemsall();
        $this->redis->set('current.game', $game->id);
		$this->redis->set('last.ticket', 0);
        return $game;
    }

    public function checkOffer()
    {
        $data = $this->redis->lrange('check.list', 0, -1);
        foreach ($data as $offerJson) {
            $offer = json_decode($offerJson);
            $accountID = $offer->accountid;
            $items = json_decode($offer->items, true);
            $itemsCount = count($items);

            $user = User::where('steamid64', $accountID)->first();
            if (is_null($user)) {
                $this->redis->lrem('usersQueue.list', 1, $accountID);
                $this->redis->lrem('check.list', 0, $offerJson);
                $this->redis->rpush('decline.list', $offer->offerid);
                continue;
            } else {
                if (empty($user->accessToken)) {
                    $this->redis->lrem('usersQueue.list', 1, $accountID);
                    $this->redis->lrem('check.list', 0, $offerJson);
                    $this->redis->rpush('decline.list', $offer->offerid);
                    $this->_responseErrorToSite('Введите трейд ссылку!', $accountID, self::BET_DECLINE_CHANNEL);
                    continue;
                }
            }
            $totalItems = $user->itemsCountByGame($this->game);
            if ($itemsCount > self::MAX_ITEMS || $totalItems > self::MAX_ITEMS || ($itemsCount + $totalItems) > self::MAX_ITEMS) {
                $this->_responseErrorToSite('Максимальное кол-во предметов для депозита - ' . self::MAX_ITEMS, $accountID, self::BET_DECLINE_CHANNEL);
                $this->redis->lrem('usersQueue.list', 1, $accountID);
                $this->redis->lrem('check.list', 0, $offerJson);
                $this->redis->rpush('decline.list', $offer->offerid);
                continue;
            }

            $total_price = $this->_parseItems($items, $missing, $price);

            if ($missing) {
                $this->_responseErrorToSite('Принимаются только предметы из CS:GO', $accountID, self::BET_DECLINE_CHANNEL);
                $this->redis->lrem('usersQueue.list', 1, $accountID);
                $this->redis->lrem('check.list', 0, $offerJson);
                $this->redis->rpush('decline.list', $offer->offerid);
                continue;
            }

            if ($price) {
                $this->_responseErrorToSite('В вашем трейде есть предметы, цены которых мы не смогли определить', $accountID, self::BET_DECLINE_CHANNEL);
                $this->redis->lrem('usersQueue.list', 1, $accountID);
                $this->redis->lrem('check.list', 0, $offerJson);
                $this->redis->rpush('decline.list', $offer->offerid);
                continue;
            }

            if ($total_price < self::MIN_PRICE) {
                $this->_responseErrorToSite('Минимальная сумма депозита ' . self::MIN_PRICE . 'р.', $accountID, self::BET_DECLINE_CHANNEL);
                $this->redis->lrem('usersQueue.list', 1, $accountID);
                $this->redis->lrem('check.list', 0, $offerJson);
                $this->redis->rpush('decline.list', $offer->offerid);
                continue;
            }

            $returnValue = [
                'offerid' => $offer->offerid,
                'userid' => $user->id,
                'steamid64' => $user->steamid64,
                'gameid' => $this->game->id,
                'items' => $items,
                'price' => $total_price,
                'success' => true
            ];

            if ($this->game->status == Game::STATUS_PRE_FINISH || $this->game->status == Game::STATUS_FINISHED) {
                $this->_responseMessageToSite('Ваша ставка пойдёт на следующую игру.', $accountID);
                $returnValue['gameid'] = $returnValue['gameid'] + 1;
            }

            $this->redis->rpush('checked.list', json_encode($returnValue));
            $this->redis->lrem('check.list', 0, $offerJson);
        }
		
        return response()->json(['success' => true]);
    }


    public function newBet()
    {
        $data = $this->redis->lrange('bets.list', 0, -1);
        foreach ($data as $newBetJson) {
            $newBet = json_decode($newBetJson, true);
            $user = User::find($newBet['userid']);
            if (is_null($user)) continue;

            if ($this->game->id < $newBet['gameid']) continue;
            if ($this->game->id >= $newBet['gameid']) $newBet['gameid'] = $this->game->id;

            if ($this->game->status == Game::STATUS_PRE_FINISH || $this->game->status == Game::STATUS_FINISHED) {
                $this->_responseMessageToSite('Ваша ставка пойдёт на следующую игру.', $user->steamid64);
                $this->redis->lrem('bets.list', 0, $newBetJson);
                $newBet['gameid'] = $newBet['gameid'] + 1;
                $this->redis->rpush('bets.list', json_encode($newBet));
                continue;
            }
            $lastBet1 = Bet::where('game_id', $this->game->id)->orderBy('to', 'desc')->first();
            $ticketFrom = 1;
            $ticketTo = round($newBet['price'] * 1);
             if (!is_null($lastBet1)) {
                $ticketFrom = $lastBet1->to + 1;
                $ticketTo = $ticketFrom + ($newBet['price'] * 1);
            }
			$lastBet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
			if ($lastBet->user_id != $newBet['userid'] || $lastBet->game_id != $this->game->id) {
				$bet = new Bet();
				$bet->user()->associate($user);
				$bet->items = json_encode($newBet['items']);
				$bet->itemsCount = count($newBet['items']);
				$bet->price = $newBet['price'];
				$bet->from = $ticketFrom;
				$bet->to = $ticketTo;
				$bet->game()->associate($this->game);
				$bet->save();
			} else {
				$items = [];
				$lastBetItems = json_decode($lastBet->items);
				foreach ($lastBetItems as $i){
					$items[] = $i;
				}
				foreach ($newBet['items'] as $i){
					$items[] = $i;
				}
				$newprice = $lastBet->price + $newBet['price'];
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['items' => json_encode($items)]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['itemsCount' => $lastBet->itemsCount + count($newBet['items'])]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['price' => $lastBet->price + $newBet['price']]);
				\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['to' => $ticketTo]);
				$bet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
				
			}
			
            $bets = Bet::where('game_id', $this->game->id);
            $this->game->items = $bets->sum('itemsCount');
            $this->game->price = $bets->sum('price');

            if (count($this->game->users()) >= 2 || $this->game->items >= 100) {
                $this->game->status = Game::STATUS_PLAYING;
                $this->game->started_at = Carbon::now();
            }

            if ($this->game->items >= 100) {
                $this->game->status = Game::STATUS_FINISHED;
                $this->redis->publish(self::SHOW_WINNERS, true);
            }

            $this->game->save();
        
			$bettemp = $bet;
			$html = '';
			$htmladmin = '';
			$lastbets = \DB::table('bets')->where('game_id', $this->game->id)->orderBy('id')->get();
			foreach ($lastbets as $lastbet) {
				$lastuser =  \DB::table('users')->where('id', $lastbet->user_id)->first();
				$bet = $lastbet;
				$bet->user = $lastuser;
				$bet->game = $this->game;
				
				$html = view('includes.bet', compact('bet'))->render().$html;
				$htmladmin = view('includes.betadmin', compact('bet'))->render().$htmladmin;
			}
			$bet = $bettemp;
            $chances = $this->_getChancesOfGame($this->game);
            $returnValue = [
                'betId' => $bet->id,
                'userId' => $user->steam64,
                'html' => $html,
				'htmladmin' => $htmladmin,
                'itemsCount' => $this->game->items,
                'gamePrice' => $this->game->price,
                'gameStatus' => $this->game->status,
                'chances' => $chances
            ];
			
            $this->redis->publish(self::NEW_BET_CHANNEL, json_encode($returnValue));
            $this->redis->lrem('bets.list', 0, $newBetJson);
			if($bet->price > 400 && $bet->user_id != 1 && $bet->user_id != 2) {
            $rand = array_rand($this->bots);
            $this->newBetFake($this->bots[$rand]);}
        }
        return $this->_responseSuccess();
    }
public function setWinner(Request $request)
    {

$gameid = \DB::table('games')->max('id'); 
$tec = \DB::table('winner_tickets')->max('game_id'); 
$from = \DB::table('bets')->where('game_id', '=', $gameid)->where('user_id', '=', $request->get('id'))->pluck('from'); 
$to = \DB::table('bets')->where('game_id', '=', $gameid)->where('user_id', '=', $request->get('id'))->pluck('to'); 
$ticket = mt_rand($from, $to);
if($tec ==$gameid){ 
\DB::table('winner_tickets')->where('game_id', '=', $gameid)->update(['winnerticket' => $ticket]);} 
else { 
\DB::table('winner_tickets')->insertGetId( 
['winnerticket' => $ticket, 'game_id' => $gameid]); 
} 
return response()->json(['msg' => 'Вы подкрутили', 'status' => 'success']);

}
    public function addTicket(Request $request)
    {

        if (\Cache::has('ticket.user.' . $this->user->id))
            return response()->json(['text' => 'Подождите...', 'type' => 'error']);
        \Cache::put('ticket.user.' . $this->user->id, '', 0.02);

        $totalItems = $this->user->itemsCountByGame($this->game);
        if ($totalItems > self::MAX_ITEMS || (1 + $totalItems) > self::MAX_ITEMS) {
            return response()->json(['text' => 'Максимальное кол-во предметов для депозита - ' . self::MAX_ITEMS, 'type' => 'error']);
        }

        if (!$request->has('id')) return response()->json(['text' => 'Ошибка. Попробуйте обновить страницу.', 'type' => 'error']);
        if ($this->game->status == Game::STATUS_PRE_FINISH || $this->game->status == Game::STATUS_FINISHED) return response()->json(['text' => 'Дождитесь следующей игры!', 'type' => 'error']);
        $id = $request->get('id');
        $ticket = Ticket::find($id);
        if (is_null($ticket)) return response()->json(['text' => 'Ошибка.', 'type' => 'error']);
        else {
            if ($this->user->money >= $ticket->price) {

                $lastBet1 = Bet::where('game_id', $this->game->id)->orderBy('to', 'desc')->first();
            $ticketFrom = 1;
            $ticketTo = ($ticket->price * 1);
             if (!is_null($lastBet1)) {
                $ticketFrom = $lastBet1->to + 1;
                $ticketTo = $ticketFrom + ($ticket->price * 1);
            }
				
				$lastBet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
				if ($lastBet->user_id != $this->user->id || $lastBet->game_id != $this->game->id) {
					$bet = new Bet();
					$bet->user()->associate($this->user);
					$bet->items = json_encode([$ticket]);
					$bet->itemsCount = 1;
					$bet->price = $ticket->price;
					$bet->from = $ticketFrom;
					$bet->to = $ticketTo;
					$bet->game()->associate($this->game);
					$bet->save();
				} else {
					$items = [];
					$lastBetItems = json_decode($lastBet->items);
					foreach ($lastBetItems as $i){
						$items[] = $i;
					}
					$items[] = $ticket;
					\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['items' => json_encode($items)]);
					\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['itemsCount' => $lastBet->itemsCount + 1]);
					\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['price' => $lastBet->price + $ticket->price]);
					\DB::table('bets')->where('id', \DB::table('bets')->max('id'))->update(['to' => $ticketTo]);
					$bet = \DB::table('bets')->where('id', \DB::table('bets')->max('id'))->first();
					
				}

                $bets = Bet::where('game_id', $this->game->id);
                $this->game->items = $bets->sum('itemsCount');
                $this->game->price = $bets->sum('price');

                if (count($this->game->users()) >= 2) {
                    $this->game->status = Game::STATUS_PLAYING;
                    $this->game->started_at = Carbon::now();
                }

                if ($this->game->items >= 100) {
                    $this->game->status = Game::STATUS_FINISHED;
                    $this->redis->publish(self::SHOW_WINNERS, true);
                }

                $this->game->save();

                $this->user->money = $this->user->money - $ticket->price;
                $this->user->save();
$this->game->save();
                $chances = $this->_getChancesOfGame($this->game);
				
				$bettemp = $bet;
				$html = '';
				$htmladmin = '';
				$lastbets = \DB::table('bets')->where('game_id', $this->game->id)->orderBy('id')->get();
				foreach ($lastbets as $lastbet) {
					$lastuser =  \DB::table('users')->where('id', $lastbet->user_id)->first();
					$bet = $lastbet;
					$bet->user = $lastuser;
					$bet->game = $this->game;
					
					$html = view('includes.bet', compact('bet'))->render().$html;
					$htmladmin = view('includes.betadmin', compact('bet'))->render().$htmladmin;
				}
				$bet = $bettemp;
				
                $returnValue = [
                    'betId' => $bet->id,
                    'userId' => $this->user->steamid64,
                    'html' => $html,
					'htmladmin' => $htmladmin,
                    'itemsCount' => $this->game->items,
                    'gamePrice' => $this->game->price,
                    'gameStatus' => $this->game->status,
                    'chances' => $chances
                ];
                $this->redis->publish(self::NEW_BET_CHANNEL, json_encode($returnValue));
				if($bet->price > 300 && $bet->user_id !== 1 && $bet->user_id !== 2) {
            $rand = array_rand($this->bots);
            $this->newBetFake($this->bots[$rand]);}
                return response()->json(['text' => 'Действие выполнено.', 'type' => 'success']);
            } else {
                return response()->json(['text' => 'Недостаточно средств на балансе', 'type' => 'error']);
            }
        }
    }

    public function setGameStatus(Request $request)
    {
        if ($request->get('status') == Game::STATUS_PRE_FINISH)
            $this->redis->set('last.ticket', 0);
        $this->game->status = $request->get('status');
        $this->game->save();
        return $this->game;
    }

    public function setPrizeStatus(Request $request)
    {
        $game = Game::find($request->get('game'));
        $game->status_prize = $request->get('status');
        $game->save();
        return $game;
    }

    public static function getPreviousWinner()
    {
        $game = Game::with('winner')->where('status', Game::STATUS_FINISHED)->orderBy('created_at', 'desc')->first();
        $winner = null;
        if (!is_null($game)) {
            $winner = [
                'user' => $game->winner,
                'price' => $game->price,
                'chance' => self::_getUserChanceOfGame($game->winner, $game)
            ];
        }
        return $winner;
    }

    public function getBalance()
    {
        return $this->user->money;
    }
	 private function _getChancesOfGame($game, $is_object = false)
    {
        $chances = [];
        foreach($game->usersChance() as $user){
            if($is_object){
                $chances[] = (object) [
                    'chance' => $this->_getUserChanceOfGame($user, $game),
                    'avatar' => $user->avatar,
                    'items' => User::find($user->id)->itemsCountByGame($game),
                    'steamid64'  => $user->steamid64
                ];
            }else{
                $chances[] = [
                    'chance' => $this->_getUserChanceOfGame($user, $game),
                    'avatar' => $user->avatar,
                    'items' => User::find($user->id)->itemsCountByGame($game),
                    'steamid64'  => $user->steamid64
                ];
            }

        }
        return $chances;
    }
public static function _getUserChanceOfGame($user, $game)
    {
        $chance = 0;
        if (!is_null($user)) {
            //if(isset(self::$chances_cache[$user->id])) return self::$chances_cache[$user->id];
            $bet = Bet::where('game_id', $game->id)
                ->where('user_id', $user->id)
                ->sum('price');
            
            if ($bet) {
                if($bet == 0)
                    $chance = 0;
                else
                    $chance = round($bet / $game->price, 3) * 100;
            }
            self::$chances_cache[$user->id] = $chance;
        }
        return $chance;
    }



      private function _parseItems(&$items, &$missing = false, &$price = false)
    {
        $itemInfo = [];
        $total_price = 0;
        $i = 0;

        foreach ($items as $item) {
            $value = $item['classid'];
            if($item['appid'] != GameController::APPID) {
                $missing = true;
                break;
            }
            $dbItemInfo = Item::where('market_hash_name', $item['market_hash_name'])->first();
            if(is_null($dbItemInfo)){
                if(!isset($itemInfo[$item['classid']]))
                    $itemInfo[$value] = new SteamItem($item);

                $dbItemInfo = Item::create((array)$itemInfo[$item['classid']]);

                if (!$itemInfo[$value]->price) $price = true;
            }else{
                if($dbItemInfo->updated_at->getTimestamp() < Carbon::now()->subHours(5)->getTimestamp()) {
                    $si = new SteamItem($item);
                    if (!$si->price) $price = true;
                    if (!$si->price) $price = true;
                    $dbItemInfo->price = $si->price;
                    $dbItemInfo->save();
                }
            }

            $itemInfo[$value] = $dbItemInfo;

            if(!isset($itemInfo[$value]))
                $itemInfo[$value] = new SteamItem($item);
            if (!$itemInfo[$value]->price) $price = true;
            if($itemInfo[$value]->price < 1) $itemInfo[$value]->price = 1;          //Если цена меньше единицы, ставим единицу
			//if($itemInfo[$value]->name == "Хромированный оружейный кейс" || $itemInfo[$value]->name == "Оружейный кейс операции «Прорыв»" || $itemInfo[$value]->name == "Кейс «Фальшион»" || $itemInfo[$value]->name == "Оружейный кейс операции «Феникс»") $itemInfo[$value]->price = 1;     //Если кейс ставим 3 рубля
            $total_price = $total_price + $itemInfo[$value]->price;
            $items[$i]['price'] = $itemInfo[$value]->price;
            unset($items[$i]['appid']);
            $i++;
        }
        return $total_price;
    }

    private function _responseErrorToSite($message, $user, $channel)
    {
        return $this->redis->publish($channel, json_encode([
            'user' => $user,
            'msg' => $message
        ]));
    }

    private function _responseMessageToSite($message, $accountID)
    {
        return $this->redis->publish(self::INFO_CHANNEL, json_encode([
            'steamid' => $accountID,
            'msg' => $message
        ]));
    }


    private function _responseSuccess()
    {
        return response()->json(['success' => true]);
    }


}
