<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use App\User;
use App\Item;
use Config;
use App\Giveaway;
use App\Giveaway_items;
class GiveawayController extends Controller
{
    const ADD_ITEMS               = 'additemsgiveaway';
	const NEW_USER                = 'newusergiveaway';
    const APPID                   = '730';
    const SEND_ITEM               = 'senditemsgiveaway';
    const END_GIVEAWAY            = 'endgiveaway';
  

    public function __construct()
    {
        parent::__construct();
        $this->giveaway = $this->getLastGame();
    }
    public function index()
    {
    	$giveaway = Giveaway::where('status', 4)->orderBy('created_at', 'desc')->simplePaginate(50);
    	return view('pages.giveaway', compact('giveaway', 'title'));
    }

    public function accept()
    {
		$giveaway_users = explode(",", $this->giveaway->users); 
		$me = 0;
		if($this->giveaway->users != NULL){
			foreach($giveaway_users as $user){
			if ($user == $this->user->id) $me = 1;
		}
		}
        if(!strstr(strtolower($this->user->username), strtolower('showlucky.ru'))){
            $result = response()->json([ 'status' => 'error', 'msg' => 'Для участия добавьте в ник showlucky.ru']); 
        } elseif($me == 1) {
            $result = response()->json([ 'status' => 'error', 'msg' => 'Вы уже учавствуете в розыгрыше!'.count($giveaway_users).'']);            
        } elseif(!$this->giveaway->users){
			$this->giveaway->users = "".$this->user->id."";
			$this->giveaway->status = Giveaway::STATUS_PLAYING;
		   $this->giveaway->save();
		   
            $result = response()->json([ 'status' => 'success','msg' => 'Вы приняли участие в розыгрыше!']);    
		} else {
           $this->giveaway->users = "".$this->giveaway->users.",".$this->user->id."";
		   $this->giveaway->save();
           $result = response()->json([ 'status' => 'success','msg' => 'Вы приняли участие в розыгрыше!']);    
        }
        if(count($giveaway_users) == $this->giveaway->max_user){
            $this->end_giveaway();
        }
		$returnValue = [
                    'avatar' => $this->user->avatar,
					'name' => $this->user->username,
					'users' => count($giveaway_users)+1
                ];
        $this->redis->publish(self::NEW_USER, json_encode($returnValue));
        return $result;
    }
    public function new_giveaway()
    {
		$item = Giveaway_items::where('status',0)->orderBy('id', 'desc')->first();
        $max_users = round($item->price) + mt_rand(7, 12);
        $giveaway = Giveaway::create(['max_user' => $max_users, 'items' => '['.json_encode($item).']']);
        //$this->redis->rpush(self::END_GIVEAWAY, json_encode($giveaway));
	    return $giveaway;
    }
    public function end_giveaway()
    {
		$giveaway_users = explode(",", $this->giveaway->users); 
        $winner_id = array_rand($giveaway_users,1);
        $winner = User::where('id', $giveaway_users[$winner_id])->first();
        $this->giveaway->winner_id         	= $winner->id;
        $this->giveaway->status    			= Giveaway::STATUS_FINISHED;
        $this->giveaway->save();

        $this->sendItems(json_decode($this->giveaway->items),$winner);
        $this->new_giveaway();
    }

    public function getLastGame()
    {
        $giveaway = Giveaway::orderBy('id', 'desc')->first();
        if(is_null($giveaway)) $giveaway = $this->new_giveaway();
        return $giveaway;
    }
    public function addItems()
    {
        $jsonItems = $this->redis->lrange(self::ADD_ITEMS, 0, -1);
        foreach($jsonItems as $jsonItem){
            $items = json_decode($jsonItem, true);
            foreach($items as $item) {
                $dbItemInfo = Item::where('market_hash_name', $item['market_hash_name'])->first();
                if (is_null($dbItemInfo)) {
                    $itemInfo = new SteamItem($item);
                    $item['price'] = $itemInfo->price;
                    Giveaway_items::create($item);
                }else{
                    $item['price'] = $dbItemInfo->price;
                    Giveaway_items::create($item);
                }
            }
            $this->redis->lrem(self::ADD_ITEMS, 1, $jsonItem);
        }
        return response()->json(['success' => true]);
    }   
	
    public function sendItems($item, $user)
    {
        $value = [
            'appId' => self::APPID,
            'steamid' => $user->steamid64,
            'accessToken' => $user->accessToken,
            'items' => $item
        ];

        $this->redis->rpush(self::SEND_ITEM, json_encode($value));
        return $item;
    }
    public function setGiveawayStatus(Request $request)
    {
        $this->giveaway->status = $request->get('status');
        $this->giveaway->save();
        return $this->giveaway;
    }
	public function setPrizeStatus(Request $request)
    {
        $this->giveaway->status_prize = $request->get('status');
        $this->giveaway->save();
        return $this->giveaway;
    }
}
