<?php

namespace App\Http\Controllers;

use App\Bet;
use App\Game;
use App\Item;
use App\Services\SteamItem;
use App\User;
use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Controllers\Controller;

class PagesController extends Controller
{

 public function pay(Request $request)
    {
		$sum = $request->get('sum');
        $u = $this->user->steamid64;
        $merchant_id = '20032';
        $secret_word = 'fb5r8uxr';
        $sign = md5($merchant_id.':'.$sum.':'.$secret_word.':'.$u);
		$url = 'https://www.free-kassa.ru/merchant/cash.php?m='.$merchant_id.'&oa='.$sum.'&o='.$u.'&s='.$sign.'&lang=ru&i=&em=';
		$returnValue = [
                    'redirect' => $url
        ];
        return $returnValue;
    }
 public function ref()
    {
            $tickets = \DB::table('ref_list')->where('ref_id',$this->user->steamid64)->orderBy('id')->get();
        return view('pages.ref', compact('tickets'));
    }
	public function about()
    {
        return view('pages.about');
    }



     public function top()
    {
        $users = \DB::table('users')
		    ->where('is_admin', 0)
            ->select('users.id',
                'users.username',
                'users.avatar',
                'users.steamid64',
                \DB::raw('SUM(games.price) as top_value'),
                \DB::raw('COUNT(games.id) as wins_count')
            )
            ->join('games', 'games.winner_id', '=', 'users.id')
            ->groupBy('users.id')
            ->orderBy('top_value', 'desc')
            ->limit(20)
            ->get();
        $place = 1;
        $i = 0;
        foreach($users as $u){
            $users[$i]->games_played = count(\DB::table('games')
                ->join('bets', 'games.id', '=', 'bets.game_id')
                ->where('bets.user_id', $u->id)
                ->groupBy('bets.game_id')
                ->select('bets.id')->get());
            $users[$i]->win_rate = round($users[$i]->wins_count / $users[$i]->games_played, 3) * 100;
            $users[$i]->rang = ($i < 19) ? $i+1 : 18;
            $i++;
        }
        return view('pages.top', compact('users', 'place'));
    }





    public function history()
    {
        $games = Game::with(['bets', 'winner'])
            ->where('status', Game::STATUS_FINISHED)
            ->orderBy('created_at', 'desc')
            ->limit(10)
            ->get();
 
        foreach($games as $key => $game) {
            $items = array();
            $price = array();
            foreach($game->bets as $bet) {
                foreach(json_decode($bet->items) as $item) {
                    $items[] = (array)$item;
                    $price[] = (array)$item->price;
                }
            }
            array_multisort($price, SORT_DESC, $items);
            $games[$key]->game_items = json_encode($items);
           $games[$key]->chance = $this->_getChancesOfGame($game, true);
        }

        return view('pages.history', compact('games'));
    }
	public function profile_history()
    {
        $games = Game::with(['bets', 'winner'])
            ->where('status', Game::STATUS_FINISHED)
            ->where('games.winner_id', $this->user->id)
            ->orderBy('created_at', 'desc')
            ->limit(10)
            ->get();
 
        foreach($games as $key => $game) {
            $items = array();
            $price = array();
            foreach($game->bets as $bet) {
                foreach(json_decode($bet->items) as $item) {
                    $items[] = (array)$item;
                    $price[] = (array)$item->price;
                }
            }
            array_multisort($price, SORT_DESC, $items);
            $games[$key]->game_items = json_encode($items);
            $games[$key]->chance = json_encode($this->_getChancesOfGame($game));
        }

        return view('pages.myhistory', compact('games'));
    }
	public static function _getUserChanceOfGame($user, $game)
    {
        $chance = 0;
        if (!is_null($user)) {
            //if(isset(self::$chances_cache[$user->id])) return self::$chances_cache[$user->id];
            $bet = Bet::where('game_id', $game->id)
                ->where('user_id', $user->id)
                ->sum('price');
            
            if ($bet) {
                if($bet == 0)
                    $chance = 0;
                else
                    $chance = round($bet / $game->price, 3) * 100;
            }
        }
        return $chance;
    }
private function _getChancesOfGame($game, $is_object = false)
    {
        $chances = [];
        foreach($game->usersChance() as $user){
            if($is_object){
                $chances[] = (object) [
                    'chance' => $this->_getUserChanceOfGame($user, $game),
                    'avatar' => $user->avatar,
                    'steamid64'  => $user->steamid64,
                    'username' => $user->username
                ];

            }else{
                $chances[] = [
                    'chance' => $this->_getUserChanceOfGame($user, $game),
                    'avatar' => $user->avatar,
                    'steamid64'  => $user->steamid64,
                    'username' => $user->username
                ];
            }

        }
        return $chances;
    }





}
