<?php

namespace App\Http\Controllers;

use App\Item;
use App\Services\SteamItem;
use App\Shop;
use App\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Cache;
use App\Http\Requests;
use App\Http\Controllers\Controller;

class ShopController extends Controller
{
const NEW_ITEMS_CHANNEL = 'items.to.sale';
const GIVE_ITEMS_CHANNEL = 'items.to.give';
const CHECK_ITEMS_CHANNEL = 'items.to.check';
const CHECKGAME = 1; //Проверять на сумму депозитов.
	const CHECKGAMECOUNT = 5; // сумма депозитов.
	const ENBL = 1; //Включить магаз
	const MAX = 10; // Предметов за трейд
	const MAXDAY = 10; // Предметов за день
	const MAXSUM = 700; // Сумма вывода в день без подтверждения
	const CHECKSUP = 1; //Включить подтверждение?

const PRICE_PERCENT_TO_SALE = 90; // Процент от цены steam

private function _responseMessageToSite($message, $userid)
{
return $this->redis->publish(GameController::INFO_CHANNEL, json_encode([
'steamid' => $userid,
'message' => $message
]));
}
public function index(){
parent::setTitle('Магазин | ');
$items = Shop::where('status', Shop::ITEM_STATUS_FOR_SALE)
->groupBy('classid')
->orderBy('price', 'desc')
->orderBy('name')
->get();
return view('pages.shop.index', compact('items'));
}

public function deposits()
    {
		$items = \DB::table('deposits')->where('userid', $this->user->steamid64)->orderBy('id', 'desc')->get();
        return view('pages.shop.offers', compact('items'));
    }

public function shop(){
$returnValue = [];
$items = Shop::where('status', Shop::ITEM_STATUS_FOR_SALE)
->groupBy('classid')
->orderBy('price', 'desc')
->orderBy('name')
->get();
foreach ($items as $item) {
$returnValue[] = [
$item->id, 
Shop::countItem($item->classid), 
$item->name, 
$item->price, 
$item->classid, 
$item->quality, 
Shop::getClassRarity($item->rarity), 
$item->rarity
];
}
return response()->json(['list' => $returnValue, 'off' => false]);
}

public function setItemStatus(Request $request){
$itemid = \DB::table('shop')->where('inventoryId', $request->get('id'))->pluck('id');
$item = Shop::find($itemid);
if(!is_null($item)){
$item->status = $request->get('status');
$item->save();
if ($request->get('status') == Shop::ITEM_STATUS_ERROR_TO_SEND){
\DB::table('shop')->insertGetId([
'name' => $item->name,
'classid' => $item->classid, 
'inventoryId' => $item->inventoryId, 
'rarity' => $item->rarity, 
'type' => $item->type, 
'quality' => $item->quality, 
'status' => Shop::ITEM_STATUS_FOR_SALE, 
'steam_price' => $item->steam_price, 
'price' => $item->price
]);
$user = User::where('steamid64',$item->buyer_id)->first();
$user->money = $user->money + $item->price;
$user->save();
}
return $item;
}
return response()->json(['success' => false]);
}

public function addItemsToSale(){
$jsonItems = $this->redis->lrange(self::NEW_ITEMS_CHANNEL, 0, -1);
foreach($jsonItems as $jsonItem){
$items = json_decode($jsonItem, true);
foreach($items as $item) {
$dbItemInfo = Item::where('market_hash_name', $item['market_hash_name'])->first();
if (is_null($dbItemInfo)) {
$itemInfo = new SteamItem($item);
$item['steam_price'] = $itemInfo->price;
$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
$userid = $item['depositorid'];
$user = User::where('steamid64', $userid)->first();
if (!is_null($user)){
if ($item['steam_price'] < 5){
							$item['price'] = round($item['steam_price']/2);
													} else {
							$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
					}
if ($item['steam_price'] <= 5){
							$item['price'] = round($item['steam_price']/2);
							\DB::table('deposits')->insertGetId( ['name' => $item['name'],'type' => '1', 'price' => round($item['steam_price']/2),'classid' => $item['classid'],'userid' => $item['depositorid'],'add_at' => Carbon::now()]); 
						} else {
							$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
							\DB::table('deposits')->insertGetId( ['name' => $item['name'],'type' => '1',  'price' => round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE),'classid' => $item['classid'],'userid' => $item['depositorid'],'add_at' => Carbon::now()]); 
						}
Shop::create($item);
if ($user->ban == 0){
$itemc = \DB::table('shop')->where('inventoryId', $item['inventoryId'])->first();
\DB::table('shop')->where('id', '=', $itemc->id)->update(['status' => 6, 'buyer_id' => $user->steamid64]);
\DB::table('shopcart')->insertGetId([
'name' => $itemc->name,
'classid' => $itemc->classid, 
'inventoryId' => $itemc->inventoryId, 
'rarity' => $itemc->rarity, 
'type' => $itemc->type, 
'quality' => $itemc->quality, 
'buyer_id' => $user->steamid64, 
'status' => 0, 
'steam_price' => $itemc->steam_price, 
'price' => $itemc->price, 
'buy_at' => $itemc->buy_at 
]);
}
} else {
Shop::create($item);
}
} else {
$item['steam_price'] = $dbItemInfo->price;
$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
$userid = $item['depositorid'];
$user = User::where('steamid64', $userid)->first();
if (!is_null($user)){
if ($item['steam_price'] < 5){
							$item['price'] = round($item['steam_price']/2);
													} else {
							$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
					}
if ($item['steam_price'] <= 5){
							$item['price'] = round($item['steam_price']/2);
							\DB::table('deposits')->insertGetId( ['name' => $item['name'],'type' => '1', 'price' => round($item['steam_price']/2),'classid' => $item['classid'],'userid' => $item['depositorid'],'add_at' => Carbon::now()]); 
						} else {
							$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
							\DB::table('deposits')->insertGetId( ['name' => $item['name'],'type' => '1',  'price' => round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE),'classid' => $item['classid'],'userid' => $item['depositorid'],'add_at' => Carbon::now()]); 
						}
Shop::create($item);
if ($user->ban == 0){
$itemc = \DB::table('shop')->where('inventoryId', $item['inventoryId'])->first();
\DB::table('shop')->where('id', '=', $itemc->id)->update(['status' => 6, 'buyer_id' => $user->steamid64]);
\DB::table('shopcart')->insertGetId([
'name' => $itemc->name,
'classid' => $itemc->classid, 
'inventoryId' => $itemc->inventoryId, 
'rarity' => $itemc->rarity, 
'type' => $itemc->type, 
'quality' => $itemc->quality, 
'buyer_id' => $user->steamid64, 
'status' => 0, 
'steam_price' => $itemc->steam_price, 
'price' => $itemc->price, 
'buy_at' => $itemc->buy_at 
]);
}
} else {
Shop::create($item);
}
}
}
$this->redis->lrem(self::NEW_ITEMS_CHANNEL, 1, $jsonItem);
$this->_responseMessageToSite('Предметы добавлены вам в корзину' , $userid);
}
return response()->json(['success' => true]);
}

public function checkShop(){
$cartitems = \DB::table('shopcart')->where('status', 0)->orderBy('id', 'desc')->get();
foreach ($cartitems as $item) {
$user = User::where('steamid64',$item->buyer_id)->first();
$user->money = $user->money + $item->price;
$user->save();
}
\DB::table('shop')->truncate();
\DB::table('shopcart')->truncate();
$jsonItems = $this->redis->lrange(self::CHECK_ITEMS_CHANNEL, 0, -1);
$items = Shop::where('status', Shop::ITEM_STATUS_FOR_SALE)->delete();
$itemz = \DB::table('shop')->get();
foreach($jsonItems as $jsonItem){
$itemsToAdd = json_decode($jsonItem, true);
$this->redis->lrem(self::CHECK_ITEMS_CHANNEL, 1, $jsonItem);
foreach($itemsToAdd as $item) {
$dbItemInfo = Item::where('market_hash_name', $item['market_hash_name'])->first();
if (is_null($dbItemInfo)) {
$itemInfo = new SteamItem($item);
$item['steam_price'] = $itemInfo->price;
$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
Shop::create($item);
}else{
$item['steam_price'] = $dbItemInfo->price;
$item['price'] = round($item['steam_price']/100 * self::PRICE_PERCENT_TO_SALE);
Shop::create($item);
}
}
}

return response()->json(['success' => true]);
}
 public function buyItem(Request $request)
    {
		if (self::ENBL == true){
			if (\Cache::has('shop.user.' . $this->user->steamid64))
				return response()->json(['success' => false, 'msg' => 'Подождите...']);
			\Cache::put('shop.user.' . $this->user->steamid64, '', 1);
			$item = Shop::find($request->get('id'));
			$kek = $this->user->steamid64;
			if(!is_null($item)){
				if($item->status == Shop::ITEM_STATUS_CART) {
					if ($item->buyer_id == $this->user->steamid64){
						$item->status = Shop::ITEM_STATUS_FOR_SALE;
						$item->buyer_id = NULL;
						$item->buy_at = Carbon::now();
						$item->save();
						if ($item->price < 5){
                        $this->user->money = $this->user->money +round($item->price/2);
						\DB::table('deposits')->insertGetId( ['name' => $item->name,'type' => '1', 'price' => round($item->price/2),'classid' => $item->classid,'userid' => $kek,'add_at' => Carbon::now()]); 
                        } else {
                        $this->user->money = $this->user->money + round($item->price/100 * self::PRICE_PERCENT_TO_SALE);
						\DB::table('deposits')->insertGetId( ['name' => $item->name,'type' => '1', 'price' => round($item->price/100 * self::PRICE_PERCENT_TO_SALE),'classid' => $item->classid,'userid' => $kek,'add_at' => Carbon::now()]); 
                        }
						$this->user->save();
						\DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('inventoryId', $item->inventoryId)->where('status', 0)->delete();//->update(['status' => 1]);
						return response()->json(['success' => true, 'msg' => 'Предмет успешно продан!']);
					} else {
						return response()->json(['success' => false, 'msg' => 'Предмет уже куплен!']);
					}
				}
				$games = count(\DB::table('games')
->join('bets', 'games.id', '=', 'bets.game_id')
->where('bets.user_id', $this->user->id)
->groupBy('bets.game_id')
->select('bets.id')->get());
				if($this->user->money >= $item->price){
					if(($games >= self::CHECKGAMECOUNT) || (self::CHECKGAME == 0)){
						$itemcount = count(\DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('status', 0)->get());
						$itembought = \DB::table('shop')->where('buyer_id', $this->user->steamid64)->where('status', 3)->where('buy_at', '>=', Carbon::today())->count();
							$itemcarted = \DB::table('shop')->where('buyer_id', $this->user->steamid64)->where('status', 1)->where('buy_at', '>=', Carbon::today())->count();
							$itemcart = \DB::table('shop')->where('buyer_id', $this->user->steamid64)->where('status', 6)->where('buy_at', '>=', Carbon::today())->count();
						if ( $itembought < self::MAXDAY && $itemcarted < self::MAXDAY && $itemcart < self::MAXDAY ){
						if ( $itemcount < self::MAX ){
							$bitems = \DB::table('shop')->where('buyer_id', $this->user->steamid64)->where('buy_at', '>=', Carbon::today())->get();
							$bsum = 0;
							foreach ($bitems as $i) {
								$bsum  += $i->price;
							}
							$bsum += $item->price;
							if ( $bsum < self::MAXSUM || self::CHECKSUP != 1){
								$item->status = Shop::ITEM_STATUS_CART;
								$this->user->money = $this->user->money - $item->price;
								$this->user->save();
								$item->buyer_id = $this->user->steamid64;
								$item->buy_at = Carbon::now();
								$item->save();
								$this->addCart($item);
								\DB::table('deposits')->insertGetId( ['name' => $item->name,'type' => '3', 'price' => $item->price,'classid' => $item->classid,'userid' => $item->buyer_id,'add_at' => Carbon::now()]); 
								return response()->json(['success' => true, 'msg' => 'Вы успешно купили предмет! Он добавлен в вашу корзину. Вы можете его продать кликнув 1 раз']);
							} else {
								return response()->json(['success' => false, 'msg' => 'Нельзя выводить больше '.self::MAXSUM.'р. в день ']);
							}
						} else {
							return response()->json(['success' => false, 'msg' => 'Нельзя выводить больше больше '.self::MAX.' предметов за обмен']);
						}}else{
								return response()->json(['success' => false, 'msg' => 'Нельзя выводить больше больше '.self::MAXDAY.' предметов в день']);

							}
					} else {
						return response()->json(['success' => false, 'msg' => 'Вы должны сыграть хотя бы '.self::CHECKGAMECOUNT.' игр для вывода']);
					}
				}else{
					return response()->json(['success' => false, 'msg' => 'У вас недостаточно средств для покупки.']);
				}
			} else {
				return response()->json(['success' => false, 'msg' => 'Ошибка! Предмет не найден!']);
			}
		} else {
			return response()->json(['success' => false, 'msg' => 'Покупки отключены']);
		}
    }

public static function addCart($item){
\DB::table('shopcart')->insertGetId([
'name' => $item->name,
'classid' => $item->classid, 
'inventoryId' => $item->inventoryId, 
'rarity' => $item->rarity, 
'type' => $item->type, 
'quality' => $item->quality, 
'buyer_id' => $item->buyer_id, 
'status' => 0, 
'steam_price' => $item->steam_price, 
'price' => $item->price, 
'buy_at' => $item->buy_at 
]);
}

public function sendItem($items){
$senditems = [];
foreach ($items as $item) {
$senditems[] = $item->inventoryId;
\DB::table('shopcart')->where('id', '=', $item->id)->delete();//->update(['status' => 1]);
}

$value = [
'items' => $senditems,
'steamid' => $this->user->steamid64,
'accessToken' => $this->user->accessToken,
];

$this->redis->rpush(self::GIVE_ITEMS_CHANNEL, json_encode($value));
}
public function sellitems(){
if ($this->user->ban == 0){
if (\Cache::has('shop.user.' . $this->user->steamid64)) return response()->json(['success' => false, 'msg' => 'Подождите...']);
\Cache::put('shop.user.' . $this->user->steamid64, '', 2);
$items = \DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('status', 0)->get(); 
if (count($items)>0){
$msg = 'Предметы проданы';
foreach ($items as $i){
$si = \DB::table('shop')->where('inventoryId', $i->inventoryId)->first();
$item = Shop::find($si->id);
$this->user->money = $this->user->money + $item->price;
$this->user->save();
$item->price = round($item->steam_price/100 * self::PRICE_PERCENT_TO_SALE);
$item->status = Shop::ITEM_STATUS_FOR_SALE;
$item->buyer_id = NULL;
$item->buy_at = Carbon::now();
$item->save();
\DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('inventoryId', $item->inventoryId)->where('status', 0)->delete();
}
} else {
$msg = 'Вы ничего не приобрели';
}
return response()->json(['success' => true, 'msg' => $msg]);
} else {
return response()->json(['success' => false, 'msg' => 'Вы забанены на сайте']);
}
}
public function cart(){
$items = \DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('status', 0)->orderBy('id', 'desc')->get();
$returnValue = [];
foreach ($items as $item) {
$shopitem = \DB::table('shop')->where('inventoryId', $item->inventoryId)->first();
$returnValue[] = [
$shopitem->id, 
1, 
$item->name, 
$item->price, 
$item->classid, 
$item->quality, 
Shop::getClassRarity($item->rarity), 
$item->rarity
];
}
return response()->json(['list' => $returnValue]);
}

public function getcart(){
if (\Cache::has('shop.user.' . $this->user->steamid64)) return response()->json(['success' => false, 'msg' => 'Подождите...']);
\Cache::put('shop.user.' . $this->user->steamid64, '', 5);
if ($this->user->ban == 0){
$items = \DB::table('shopcart')->where('buyer_id', $this->user->steamid64)->where('status', 0)->get(); 
if (count($items)>0){
$msg = 'Предметы будут отправлены в течение 5 минут.';
$this->sendItem($items);
} else {
$msg = 'Вы ничего не приобрели';
}
return response()->json(['success' => true, 'msg' => $msg]);
} else {
return response()->json(['success' => false, 'msg' => 'Вы забанены на сайте']);
}
}
}