<?php

namespace App\Http\Controllers;

use App\User;
use Auth;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Http\Controllers\GameController;
use App\Http\Requests;
use App\Http\Controllers\Controller;
use Invisnik\LaravelSteamAuth\SteamAuth;

class SteamController extends Controller
{
	private function _responseMessageToSite($message, $twoplayer)
    {
        return $this->redis->publish(GameController::INFO_CHANNEL, json_encode([
            'steamid' => $twoplayer,
            'message' => $message
        ]));
    }
	
	public function savecoupon(Request $request)
    {
        $user = $this->user;
        $refferal_cod = $this->_validatecoupon($request);
        if(!$request->ajax()){
            $steamInfo = $this->_getSteamInfo($user->steamid64);
            $user->username = $steamInfo->getNick();
            $user->avatar = $steamInfo->getProfilePictureFull();
        }
        if($this->user->refferal_cod != NULL){
        if($request->ajax())
        return response()->json(['msg' => 'erorr_estb', 'status' => 'error']);
        }
        else{
             $user->refferal_cod = $refferal_cod;
            $user->save();
            if($request->ajax())
                return response()->json(['msg' => 'Купон успешно сохранён', 'status' => 'successs']);
        }
    }
    private function _validatecoupon($request)
    {
        $val = \Validator::make($request->all(), [
            'refferal_cod' => 'required|string|max:20|min:3|unique:users|alpha_dash'
        ], [
            'required' => 'Сообщение не может быть пустым!',
            'string' => 'Сообщение должно быть строкой!',
            'max' => 'Максимальный размер сообщения 20 символов.',
            'min' => 'Минимальный размер сообщения 3 символа.',
            'unique' => 'Такой код уже существует',
            'alpha_dash' => 'только букв, цифр, тире и символа подчеркивания',
        ]);
        if ($val->fails()) {
            $this->throwValidationException($request, $val);
        }

        return $request->get('refferal_cod');
    }
            public function getcoupon(Request $request)
    {
        $user = $this->user;
        //Проверка на _validatecoupon1
        $code_ref = $this->_validatecoupon1($request);
        //Проверка на существующий код
        $result = \DB::table('users')->where('refferal_cod', $code_ref)->get();
        $count = count($result);
        //Проверка на 1 ставку
        $userid = htmlspecialchars_decode($this->user->id);
        $stavki = \DB::table('bets')->where('user_id', '=', $userid)->get();
        if(!$request->ajax()){
            $steamInfo = $this->_getSteamInfo($user->steamid64);
            $user->username = $steamInfo->getNick();
            $user->avatar = $steamInfo->getProfilePictureFull();
        }
        if($code_ref == $user->refferal_cod){
           return response()->json(['msg' => 'erryour', 'status' => 'successs']);
        }
        if($user->ref_activ == '1') {
            return response()->json(['msg' => 'erractive', 'status' => 'successs']);
        }
        if($count == 0) {
            return response()->json(['msg' => 'errnullcoupon', 'status' => 'successs']);
        }
        if($stavki == null) {
            return response()->json(['msg' => 'minbet', 'status' => 'successs']);
        }
        else{
            $user->code_ref = $code_ref;
            $user->ref_activ = 1;
            $user->save();
            //Берём с базы
            $ref_noviu = 15;
            $ref_prig = 5; 
            //Пополенение баланса
            $money = $user->money+$ref_noviu;
            \DB::table('users')->where('steamid64', $user->steamid64)->update(['money' => $money]);
            $ref_steamid = \DB::table('users')->where('refferal_cod', $code_ref)->pluck('steamid64');
            $ref_money = \DB::table('users')->where('refferal_cod', $code_ref)->pluck('money'); 
            $ref_money = $ref_money+$ref_prig;
            \DB::table('users')->where('steamid64', $ref_steamid)->update(['money' => $ref_money]);
            //Создание в ref_list
            $date = date("H:i:s")." | ".date("d.m.y");
            $ref_username = \DB::table('users')->where('steamid64', $user->steamid64)->pluck('username');
            \DB::table('ref_list')->insertGetId(
            ['date' => $date , 'ref_id' => $ref_steamid ,  'id_ref' => $user->steamid64 , 'ref_username' => $ref_username , 'pribil' => $ref_prig ]
            );
            if($request->ajax())
                return response()->json(['msg' => 'ok', 'status' => 'successs']);
        }
    }
        private function _validatecoupon1($request)
    {
        $val = \Validator::make($request->all(), [
            'code_ref' => 'required|string|max:20|min:3|alpha_dash'
        ], [
            'required' => 'Сообщение не может быть пустым!',
            'string' => 'Сообщение должно быть строкой!',
            'max' => 'Максимальный размер сообщения 20 символов.',
            'min' => 'Минимальный размер сообщения 3 символа.',
            'alpha_dash' => 'только букв, цифр, тире и символа подчеркивания',
        ]);
        if ($val->fails())
            $this->throwValidationException($request, $val);

        return $request->get('code_ref');
    }
    private $steamAuth;

    public function __construct(SteamAuth $auth)
    {
        parent::__construct();
        $this->steamAuth = $auth;
    }

    public function login()
    {
        if ($this->steamAuth->validate()) {
            $steamID = $this->steamAuth->getSteamId();
            $user = User::where('steamid64', $steamID)->first();
            if (!is_null($user)) {
                $steamInfo = $this->steamAuth->getUserInfo();
                \DB::table('users')
                    ->where('steamid64', $steamID)
                    ->update(['username' => $this->replaceLogin($steamInfo->getNick()),
                        'avatar' => $steamInfo->getProfilePictureFull()]);
            } else {
                $steamInfo = $this->steamAuth->getUserInfo();
                $user = User::create([
                    'username' => $this->replaceLogin($steamInfo->getNick()),
                    'avatar' => $steamInfo->getProfilePictureFull(),
                    'steamid' => $steamInfo->getSteamID(),
                    'steamid64' => $steamInfo->getSteamID64(),
                ]);

            }
            Auth::login($user, true);
            return redirect('/');
        } else {
            return $this->steamAuth->redirect();
        }
    }
public function replaceLogin($login)
    {
        if(stristr($login, 'showlucky.ru') === FALSE) {
            $login = preg_replace('/([A-Za-z0-9а-яА-Я]+\.)+(ru|com|cоm|сom|соm|net|gl|su|red|ws|us|top|pro|club|Net|pink|porn)/iu', '', $login);
        }

        return $login;
    }
    public function logout()
    {
        Auth::logout();
        return redirect('/');
    }

    public function updateSettings(Request $request)
    {
        $user = $this->user;
        if(!$request->ajax()){
            $steamInfo = $this->_getSteamInfo($user->steamid64);
            $user->username = $steamInfo->getNick();
            $user->avatar = $steamInfo->getProfilePictureFull();
        }
        if($token = $this->_parseTradeLink($link = $request->get('trade_link'))){
            $user->trade_link = $link;
            $user->accessToken = $token;
            $user->save();
            if($request->ajax())
                return response()->json(['msg' => 'Ссылка успешно сохранена', 'status' => 'success']);
            return redirect()->back()->with('successs', 'Ссылка успешно сохранена');
        }else{
            if($request->ajax())
                return response()->json(['msg' => 'Неверный формат ссылки', 'status' => 'error']);
            return redirect()->back()->with('error', 'Неверный формат ссылки');
        }
    }

    private function _parseTradeLink($tradeLink)
    {
        $query_str = parse_url($tradeLink, PHP_URL_QUERY);
        parse_str($query_str, $query_params);
        return isset($query_params['token']) ? $query_params['token'] : false;
    }
}
