<?php
    get('/login', ['as' => 'login', 'uses' => 'SteamController@login']);
    get('/', ['as' => 'index', 'uses' => 'GameController@currentGame']);
	get('/api/getGlobal', ['as' => 'index', 'uses' => 'GameController@getGlobal']);
	get('/api/getDouble', ['as' => 'index', 'uses' => 'GameController@getDouble']);
	get('/api/getCrash', ['as' => 'index', 'uses' => 'GameController@getCrash']);
	get('/api/getRef', ['as' => 'index', 'uses' => 'GameController@getRef']);
	get('/api/getMywins', ['as' => 'index', 'uses' => 'GameController@getMywins']);
	get('/api/getMyoffers', ['as' => 'index', 'uses' => 'GameController@getMyoffers']);
	get('/api/getClassic', ['as' => 'index', 'uses' => 'GameController@getClassic']);
	get('/api/getTop', ['as' => 'index', 'uses' => 'GameController@getTop']);
	get('/api/getHistory', ['as' => 'index', 'uses' => 'GameController@getHistory']);
    //get('/about', ['as' => 'about', 'uses' => 'PagesController@about']);
    //get('/top', ['as' => 'top', 'uses' => 'PagesController@top']);
    //get('/history', ['as' => 'history', 'uses' => 'PagesController@history']);
    //get('/shop', ['as' => 'cards', 'uses' => 'ShopController@index']);
	get('/giveaway', 'GiveawayController@index');
	get('/crash', ['as' => 'crash_index', 'uses' => 'CrashController@index']);

Route::group(['middleware' => 'auth'], function () {    
post('/giveaway/accept', 'GiveawayController@accept'); 
    get('/dwinner', ['as' => 'dwinner', 'uses' => 'DoubleController@dwinner', 'middleware' => 'access:admin']);
	get('/double', ['as' => 'double_index', 'uses' => 'DoubleController@double_index']);	
	post('/double/bet', ['as' => 'bet', 'uses' => 'DoubleController@newBet']);	
	post('/crash/bet/make', ['as' => 'bet', 'uses' => 'CrashController@newBet']);	
	post('/crash/bet/cashout', ['as' => 'bet', 'uses' => 'CrashController@newBet']);	
    get('/myoffers', ['as' => 'cads', 'uses' => 'ShopController@deposits']);
	post('/shop/buy', ['as' => 'settings.update', 'uses' => 'ShopController@buyItem']);
	post('/shop', ['as' => 'shop', 'uses' => 'ShopController@shop']);
	post('/cart', ['as' => 'cart', 'uses' => 'ShopController@cart']);
	post('/getcart', ['as' => 'getcart', 'uses' => 'ShopController@getcart']);
	post('/sellitems', ['as' => 'sellitems', 'uses' => 'ShopController@sellitems']);
    post('/ajax/chat', 'AjaxController@chat');
    get('/myhistory', ['as' => 'history', 'uses' => 'PagesController@profile_history']);
    post('/setWinner', ['as' => 'admin.setWinner', 'uses' => 'GameController@setWinner', 'middleware' => 'access:admin']); 
    get('/dep', ['as' => 'deposit', 'uses' => 'GameController@addbalance']);
	post('/pay', 'PagesController@pay');
	post('/savecoupon', ['as' => 'settings.update', 'uses' => 'SteamController@savecoupon']);
    post('/getcoupon', ['as' => 'settings.update', 'uses' => 'SteamController@getcoupon']);
	get('/ref', ['as' => 'ref', 'uses' => 'PagesController@ref']);
    get('/deposit', ['as' => 'deposit', 'uses' => 'GameController@deposit']);
    get('/settings', ['as' => 'settings', 'uses' => 'PagesController@settings']);
    post('/settings/save', ['as' => 'settings.update', 'uses' => 'SteamController@updateSettings']);
    get('/logout', ['as' => 'logout', 'uses' => 'SteamController@logout']);
    post('/addTicket', ['as' => 'add.ticket', 'uses' => 'GameController@addTicket']);
    post('/getBalance', ['as' => 'get.balance', 'uses' => 'GameController@getBalance']);
});


Route::group(['prefix' => 'api', 'middleware' => 'secretKey'], function () {
	post('/double/newGame', 'DoubleController@newGame');
    post('/double/startGame', 'DoubleController@startGame');
	post('/double/setGameStatus', 'DoubleController@setGameStatus');
	post('/double/getCurrentGame', 'DoubleController@getCurrentGame');
	
    post('/giveaway/addItems', 'GiveawayController@addItems');
	post('/giveaway/setGiveawayStatus', 'GiveawayController@setGiveawayStatus');
	post('/giveaway/setPrizeStatus', 'GiveawayController@setPrizeStatus');
	
	post('/crash/getCurrentGame', 'CrashController@getLastGame');
	post('/crash/newGame', 'CrashController@newGame');
	post('/crash/setGameStatus', 'CrashController@setGameStatus');
	post('/crash/finishGame', 'CrashController@finishGame');
	
    get('/checkOffer', 'GameController@checkOffer');
    get('/newBet', 'GameController@newBet');
	post('/setGameStatus', 'GameController@setGameStatus');
    post('/setPrizeStatus', 'GameController@setPrizeStatus');
    post('/getCurrentGame', 'GameController@getCurrentGame');
    post('/getWinners', 'GameController@getWinners');
    post('/getPreviousWinner', 'GameController@getPreviousWinner');
    post('/newGame', 'GameController@newGame');
	post('/getPriceItems', 'GameController@getPriceItems');
	post('/shop/newItems', 'ShopController@addItemsToSale');
    post('/shop/checkShop', 'ShopController@checkShop');
    post('/shop/setItemStatus', 'ShopController@setItemStatus');	
});



//*****ADMIN*****\\
Route::group(['middleware' => 'auth'], function () {

	get('/admin', ['as' => 'give', 'uses' => 'AdminController@adminnew']);
	get('/admin/giveaway', ['as' => 'give', 'uses' => 'AdminController@giveaway']);
	get('/admin/winner', ['as' => 'give', 'uses' => 'AdminController@winnerpage']);	
	get('/admin/bot_set', ['as' => 'give', 'uses' => 'AdminController@bot_set']);	
	get('/admin/logsclear', ['as' => 'give', 'uses' => 'AdminController@logsclear']);
	get('/admin/bot_on_fast', ['as' => 'give', 'uses' => 'AdminController@bot_on_fast']);
	get('/admin/bot_on', ['as' => 'give', 'uses' => 'AdminController@bot_on']);
	get('/admin/newkurs', ['as' => 'give', 'uses' => 'AdminController@newkurs']);
	get('/admin/laravel_log', ['as' => 'give', 'uses' => 'AdminController@laravel_log']);
	get('/admin/bot_off', ['as' => 'give', 'uses' => 'AdminController@bot_off']);
	get('/admin/bot_off_fast', ['as' => 'give', 'uses' => 'AdminController@bot_off_fast']);
	get('/admin/reboot', ['as' => 'give', 'uses' => 'AdminController@reboot']);
	get('/admin/mysql', ['as' => 'give', 'uses' => 'AdminController@mysql_restart']);
	get('/admin/apache2', ['as' => 'give', 'uses' => 'AdminController@apache2']);
	get('/admin/bot_logs_api', ['as' => 'give', 'uses' => 'AdminController@bot_logs_api']);
	get('/admin/bot_logs_api_fast', ['as' => 'give', 'uses' => 'AdminController@bot_logs_api_fast']);
	get('/admin/items', ['as' => 'give', 'uses' => 'AdminController@itemspage']);	
	get('/admin/add_items', ['as' => 'give', 'uses' => 'AdminController@add_items']);	
	get('/users/{user}', ['as' => 'users', 'uses' => 'AdminController@user']);
	get('/buy/{user}', ['as' => 'buy', 'uses' => 'AdminController@buy']);
	get('/add/{user}', ['as' => 'add', 'uses' => 'AdminController@add']);
	get('/admin/users', ['as' => 'give', 'uses' => 'AdminController@users']);	
	get('/namesite', ['as' => 'give', 'uses' => 'AdminController@namesite']);
	get('/bot1trade', ['as' => 'give', 'uses' => 'AdminController@bot1trade']);
	get('/bot2trade', ['as' => 'give', 'uses' => 'AdminController@bot2trade']);
	get('/bot3trade', ['as' => 'give', 'uses' => 'AdminController@bot3trade']);
	get('/min_price_classic', ['as' => 'give', 'uses' => 'AdminController@min_price_classic']);
	get('/max_items_classic', ['as' => 'give', 'uses' => 'AdminController@max_items_classic']);
	get('/comission', ['as' => 'give', 'uses' => 'AdminController@comission']);
	get('/minusfornick', ['as' => 'give', 'uses' => 'AdminController@minusfornick']);
	get('/backpackapi', ['as' => 'give', 'uses' => 'AdminController@backpackapi']);
	get('/gdonatepublic', ['as' => 'give', 'uses' => 'AdminController@gdonatepublic']);
	get('/gdonatesecret', ['as' => 'give', 'uses' => 'AdminController@gdonatesecret']);
	get('/max_bet_double', ['as' => 'give', 'uses' => 'AdminController@max_bet_double']);
	get('/min_bet_double', ['as' => 'give', 'uses' => 'AdminController@min_bet_double']);
	get('/priceshop', ['as' => 'give', 'uses' => 'AdminController@priceshop']);
	get('/usersgiveaway', ['as' => 'give', 'uses' => 'AdminController@usersgiveaway']);
	get('/pricegiveaway', ['as' => 'give', 'uses' => 'AdminController@pricegiveaway']);
	get('/new_giveaway', ['as' => 'give', 'uses' => 'AdminController@new_giveaway']);
	get('/add_item', ['as' => 'give', 'uses' => 'AdminController@addItem']);
	get('/userselect', ['as' => 'give', 'uses' => 'AdminController@userselect']);
	get('/addselect', ['as' => 'give', 'uses' => 'AdminController@addselect']);
	get('/buyselect', ['as' => 'give', 'uses' => 'AdminController@buyselect']);
    get('/givemoney', ['as' => 'give', 'uses' => 'AdminController@givemoney']);
    get('/takemoney', ['as' => 'give', 'uses' => 'AdminController@takemoney']);
    get('/ban', ['as' => 'give', 'uses' => 'AdminController@ban']);
    get('/deban', ['as' => 'give', 'uses' => 'AdminController@deban']);
    get('/globban', ['as' => 'give', 'uses' => 'AdminController@globban']);
    get('/deglobban', ['as' => 'give', 'uses' => 'AdminController@deglobban']);
	get('/clearsup', ['as' => 'give', 'uses' => 'AdminController@clearsup']);
	get('/clearbon', ['as' => 'give', 'uses' => 'AdminController@clearbon']);
});
//*****ADMIN*****\\