<?php namespace App\Services;

use App\Http\Controllers\GameController;
use App\Http\Controllers\SteamController;
use Exception;
use Storage;

class SteamItem {

    const BANK_URL = 'http://www.cbr.ru/scripts/XML_daily.asp';

    public  $classid;
    public  $name;
    public  $market_hash_name;
    public  $price;
    public  $rarity;
	public  $stattrak;

    public function __construct($info)
    {
        $this->classid = $info['classid'];
        $this->name = $info['name'];
        $this->market_hash_name = $info['market_hash_name'];
        $this->rarity = isset($info['rarity']) ? $info['rarity'] : $this->getItemRarity($info);
		
		if ($price = $this->getItemPrice()) {
         $this->price = round(floatval($price), 2);
        }else{
            $this->_setToFalse();
        }
        $stattrek = $info['market_hash_name'];
        $statrek = substr($stattrek,0,4);
        if($statrek == 'Stat'){
            $this->stattrak = 1;
        }else{
            $this->stattrak = 0;
        }

    }

    public function getItemPrice() { 
	$usd       = $this->getActualCurs();
		$last_update = time() - filemtime("/var/www/html/storage/app/back.txt");
		$file= "";		
		$status = false;
		$load = false;
		$error = "";
		if ($last_update > 7200) {
				$status = true;			
				$file = file_get_contents("http://backpack.tf/api/IGetMarketPrices/v1/?key=57a0fb208667472e990fc105&compress=1&appid=730");
				$json = json_decode($file, true);					
				if ($json['response']["success"]	== "1") {								
						file_put_contents("/var/www/html/storage/app/back.txt", $file);
						$load = true;
				} else {
				$error ="Somethinf wrong: ".$json['response']["message"];
				}
                    
        } 
		if ($status) {
			if ($load) {
				file_put_contents("/var/www/html/storage/app/api-log.txt", "UPDATE FROM BACKPACK ".date("Y-m-d H:i:s")." \r\n", FILE_APPEND | LOCK_EX);						
			} 	
			else {
				file_put_contents("/var/www/html/storage/app/api-log.txt", "ERROR - LOAD FROM FILE ".date("Y-m-d H:i:s")." ".$error."\r\n", FILE_APPEND | LOCK_EX);
				$file = file_get_contents("/var/www/html/storage/app/back.txt");
				$json = json_decode($file, true);
			}
		} else    {
			$file = file_get_contents("/var/www/html/storage/app/back.txt");
			$json = json_decode($file, true);				
		}
		foreach($json['response']['items'] as $name=>$item)		{					
		
			if($name == $this->market_hash_name)	{
							return $item['value']/100*$usd;
							break;
			}
		}
      
    }

    public function getActualCurs() {
        $link = self::BANK_URL;
        $str  = file_get_contents($link);

        preg_match('#<Valute ID="R01235">.*?.<Value>(.*?)</Value>.*?</Valute>#is', $str, $value);

        $usd = $value[1];

        return $usd;
    }

    public function getItemRarity($info) {
        $type = $info['type'];
        $rarity = '';
        $arr = explode(',',$type);
        if (count($arr) == 2) $type = trim($arr[1]);
        if (count($arr) == 3) $type = trim($arr[2]);
        if (count($arr) && $arr[0] == 'Нож') $type = '★';
        switch ($type) {
            case 'Армейское качество':      $rarity = 'milspec'; break;
            case 'Запрещенное':             $rarity = 'restricted'; break;
            case 'Засекреченное':           $rarity = 'classified'; break;
            case 'Тайное':                  $rarity = 'covert'; break;
            case 'Ширпотреб':               $rarity = 'common'; break;
            case 'Промышленное качество':   $rarity = 'common'; break;
            case '★':                       $rarity = 'rare'; break;
        }

        return $rarity;
    }

    private function _setToFalse()
    {
        $this->name = false;
        $this->price = false;
        $this->rarity = false;
    }
}