/*
 ProtoBuf.js (c) 2013 Daniel Wirtz <dcode@dcode.io>
 Released under the Apache License, Version 2.0
 see: https://github.com/dcodeIO/ProtoBuf.js for details
*/
(function(h,u){"function"===typeof define&&define.amd?define(["ByteBuffer"],u):"function"===typeof require&&"object"===typeof module&&module&&module.exports?module.exports=u(require("bytebuffer"),!0):(h.dcodeIO=h.dcodeIO||{}).ProtoBuf=u(h.dcodeIO.ByteBuffer)})(this,function(h,u){var d={};d.ByteBuffer=h;d.Long=h.Long||null;d.VERSION="4.1.2";d.WIRE_TYPES={};d.WIRE_TYPES.VARINT=0;d.WIRE_TYPES.BITS64=1;d.WIRE_TYPES.LDELIM=2;d.WIRE_TYPES.STARTGROUP=3;d.WIRE_TYPES.ENDGROUP=4;d.WIRE_TYPES.BITS32=5;d.PACKABLE_WIRE_TYPES=
[d.WIRE_TYPES.VARINT,d.WIRE_TYPES.BITS64,d.WIRE_TYPES.BITS32];d.TYPES={int32:{name:"int32",wireType:d.WIRE_TYPES.VARINT,defaultValue:0},uint32:{name:"uint32",wireType:d.WIRE_TYPES.VARINT,defaultValue:0},sint32:{name:"sint32",wireType:d.WIRE_TYPES.VARINT,defaultValue:0},int64:{name:"int64",wireType:d.WIRE_TYPES.VARINT,defaultValue:d.Long?d.Long.ZERO:void 0},uint64:{name:"uint64",wireType:d.WIRE_TYPES.VARINT,defaultValue:d.Long?d.Long.UZERO:void 0},sint64:{name:"sint64",wireType:d.WIRE_TYPES.VARINT,
defaultValue:d.Long?d.Long.ZERO:void 0},bool:{name:"bool",wireType:d.WIRE_TYPES.VARINT,defaultValue:!1},"double":{name:"double",wireType:d.WIRE_TYPES.BITS64,defaultValue:0},string:{name:"string",wireType:d.WIRE_TYPES.LDELIM,defaultValue:""},bytes:{name:"bytes",wireType:d.WIRE_TYPES.LDELIM,defaultValue:null},fixed32:{name:"fixed32",wireType:d.WIRE_TYPES.BITS32,defaultValue:0},sfixed32:{name:"sfixed32",wireType:d.WIRE_TYPES.BITS32,defaultValue:0},fixed64:{name:"fixed64",wireType:d.WIRE_TYPES.BITS64,
defaultValue:d.Long?d.Long.UZERO:void 0},sfixed64:{name:"sfixed64",wireType:d.WIRE_TYPES.BITS64,defaultValue:d.Long?d.Long.ZERO:void 0},"float":{name:"float",wireType:d.WIRE_TYPES.BITS32,defaultValue:0},"enum":{name:"enum",wireType:d.WIRE_TYPES.VARINT,defaultValue:0},message:{name:"message",wireType:d.WIRE_TYPES.LDELIM,defaultValue:null},group:{name:"group",wireType:d.WIRE_TYPES.STARTGROUP,defaultValue:null}};d.MAP_KEY_TYPES=[d.TYPES.int32,d.TYPES.sint32,d.TYPES.sfixed32,d.TYPES.uint32,d.TYPES.fixed32,
d.TYPES.int64,d.TYPES.sint64,d.TYPES.sfixed64,d.TYPES.uint64,d.TYPES.fixed64,d.TYPES.bool,d.TYPES.string,d.TYPES.bytes];d.ID_MIN=1;d.ID_MAX=536870911;d.convertFieldsToCamelCase=!1;d.populateAccessors=!0;d.populateDefaults=!0;d.Util=function(){var b={};b.IS_NODE=!("object"!==typeof process||"[object process]"!==process+""||process.browser);b.XHR=function(){for(var b=[function(){return new XMLHttpRequest},function(){return new ActiveXObject("Msxml2.XMLHTTP")},function(){return new ActiveXObject("Msxml3.XMLHTTP")},
function(){return new ActiveXObject("Microsoft.XMLHTTP")}],d=null,h=0;h<b.length;h++){try{d=b[h]()}catch(n){continue}break}if(!d)throw Error("XMLHttpRequest is not supported");return d};b.fetch=function(d,p){p&&"function"!=typeof p&&(p=null);if(b.IS_NODE){var h=require("fs");if(p)h.readFile(d,function(b,d){b?p(null):p(""+d)});else try{return h.readFileSync(d)}catch(n){return null}}else{var k=b.XHR();k.open("GET",d,p?!0:!1);k.setRequestHeader("Accept","text/plain");"function"===typeof k.overrideMimeType&&
k.overrideMimeType("text/plain");if(p)k.onreadystatechange=function(){4==k.readyState&&(200==k.status||0==k.status&&"string"===typeof k.responseText?p(k.responseText):p(null))},4!=k.readyState&&k.send(null);else return k.send(null),200==k.status||0==k.status&&"string"===typeof k.responseText?k.responseText:null}};b.toCamelCase=function(b){return b.replace(/_([a-zA-Z])/g,function(b,d){return d.toUpperCase()})};return b}();d.Lang={DELIM:/[\s\{\}=;:\[\],'"\(\)<>]/g,RULE:/^(?:required|optional|repeated|map)$/,
TYPE:/^(?:double|float|int32|uint32|sint32|int64|uint64|sint64|fixed32|sfixed32|fixed64|sfixed64|bool|string|bytes)$/,NAME:/^[a-zA-Z_][a-zA-Z_0-9]*$/,TYPEDEF:/^[a-zA-Z][a-zA-Z_0-9]*$/,TYPEREF:/^(?:\.?[a-zA-Z_][a-zA-Z_0-9]*)+$/,FQTYPEREF:/^(?:\.[a-zA-Z][a-zA-Z_0-9]*)+$/,NUMBER:/^-?(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+|([0-9]*(\.[0-9]*)?([Ee][+-]?[0-9]+)?)|inf|nan)$/,NUMBER_DEC:/^(?:[1-9][0-9]*|0)$/,NUMBER_HEX:/^0[xX][0-9a-fA-F]+$/,NUMBER_OCT:/^0[0-7]+$/,NUMBER_FLT:/^([0-9]*(\.[0-9]*)?([Ee][+-]?[0-9]+)?|inf|nan)$/,
BOOL:/^(?:true|false)$/i,ID:/^(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+)$/,NEGID:/^\-?(?:[1-9][0-9]*|0|0[xX][0-9a-fA-F]+|0[0-7]+)$/,WHITESPACE:/\s/,STRING:/(?:"([^"\\]*(?:\\.[^"\\]*)*)")|(?:'([^'\\]*(?:\\.[^'\\]*)*)')/g,STRING_DQ:/(?:"([^"\\]*(?:\\.[^"\\]*)*)")/g,STRING_SQ:/(?:'([^'\\]*(?:\\.[^'\\]*)*)')/g};d.DotProto=function(b,d){function h(b,c){var a=-1,f=1;"-"==b.charAt(0)&&(f=-1,b=b.substring(1));if(d.NUMBER_DEC.test(b))a=parseInt(b);else if(d.NUMBER_HEX.test(b))a=parseInt(b.substring(2),16);
else if(d.NUMBER_OCT.test(b))a=parseInt(b.substring(1),8);else throw Error("illegal id value: "+(0>f?"-":"")+b);a=f*a|0;if(!c&&0>a)throw Error("illegal id value: "+(0>f?"-":"")+b);return a}function q(b){var c=1;"-"==b.charAt(0)&&(c=-1,b=b.substring(1));if(d.NUMBER_DEC.test(b))return c*parseInt(b,10);if(d.NUMBER_HEX.test(b))return c*parseInt(b.substring(2),16);if(d.NUMBER_OCT.test(b))return c*parseInt(b.substring(1),8);if("inf"===b)return Infinity*c;if("nan"===b)return NaN;if(d.NUMBER_FLT.test(b))return c*
parseFloat(b);throw Error("illegal number value: "+(0>c?"-":"")+b);}function n(b,c,d){"undefined"===typeof b[c]?b[c]=d:(Array.isArray(b[c])||(b[c]=[b[c]]),b[c].push(d))}var k={},a=function(b){this.source=b+"";this.index=0;this.line=1;this.stack=[];this._stringOpen=null},e=a.prototype;e._readString=function(){var b='"'===this._stringOpen?d.STRING_DQ:d.STRING_SQ;b.lastIndex=this.index-1;var c=b.exec(this.source);if(!c)throw Error("unterminated string");this.index=b.lastIndex;this.stack.push(this._stringOpen);
this._stringOpen=null;return c[1]};e.next=function(){if(0<this.stack.length)return this.stack.shift();if(this.index>=this.source.length)return null;if(null!==this._stringOpen)return this._readString();var b,c;do{for(b=!1;d.WHITESPACE.test(c=this.source.charAt(this.index));)if("\n"===c&&++this.line,++this.index===this.source.length)return null;if("/"===this.source.charAt(this.index))if(++this.index,"/"===this.source.charAt(this.index)){for(;"\n"!==this.source.charAt(++this.index);)if(this.index==this.source.length)return null;
++this.index;++this.line;b=!0}else if("*"===(c=this.source.charAt(this.index))){do{"\n"===c&&++this.line;if(++this.index===this.source.length)return null;b=c;c=this.source.charAt(this.index)}while("*"!==b||"/"!==c);++this.index;b=!0}else return"/"}while(b);if(this.index===this.source.length)return null;c=this.index;d.DELIM.lastIndex=0;if(!d.DELIM.test(this.source.charAt(c++)))for(;c<this.source.length&&!d.DELIM.test(this.source.charAt(c));)++c;c=this.source.substring(this.index,this.index=c);if('"'===
c||"'"===c)this._stringOpen=c;return c};e.peek=function(){if(0===this.stack.length){var b=this.next();if(null===b)return null;this.stack.push(b)}return this.stack[0]};e.skip=function(b){var c=this.next();if(c!==b)throw Error("illegal '"+c+"', '"+b+"' expected");};e.omit=function(b){return this.peek()===b?(this.next(),!0):!1};e.toString=function(){return"Tokenizer ("+this.index+"/"+this.source.length+" at line "+this.line+")"};k.Tokenizer=a;var g=function(b){this.tn=new a(b);this.proto3=!1},e=g.prototype;
e.parse=function(){var b={name:"[ROOT]","package":null,messages:[],enums:[],imports:[],options:{},services:[]},c,a=!0;try{for(;c=this.tn.next();)switch(c){case "package":if(!a||null!==b["package"])throw Error("unexpected 'package'");c=this.tn.next();if(!d.TYPEREF.test(c))throw Error("illegal package name: "+c);this.tn.skip(";");b["package"]=c;break;case "import":if(!a)throw Error("unexpected 'import'");c=this.tn.peek();"public"===c&&this.tn.next();c=this._readString();this.tn.skip(";");b.imports.push(c);
break;case "syntax":if(!a)throw Error("unexpected 'syntax'");this.tn.skip("=");"proto3"===(b.syntax=this._readString())&&(this.proto3=!0);this.tn.skip(";");break;case "message":this._parseMessage(b,null);a=!1;break;case "enum":this._parseEnum(b);a=!1;break;case "option":this._parseOption(b);break;case "service":this._parseService(b);break;case "extend":this._parseExtend(b);break;default:throw Error("unexpected '"+c+"'");}}catch(f){throw f.message="Parse error at line "+this.tn.line+": "+f.message,
f;}delete b.name;return b};g.parse=function(b){return(new g(b)).parse()};e._readString=function(){var b="",c;do{c=this.tn.next();if("'"!==c&&'"'!==c)throw Error("illegal string delimiter: "+c);b+=this.tn.next();this.tn.skip(c);c=this.tn.peek()}while('"'===c||'"'===c);return b};e._readValue=function(b){var c=this.tn.peek();if('"'===c||"'"===c)return this._readString();this.tn.next();if(d.NUMBER.test(c))return q(c);if(d.BOOL.test(c))return"true"===c.toLowerCase();if(b&&d.TYPEREF.test(c))return c;throw Error("illegal value: "+
c);};e._parseOption=function(b,c){var a=this.tn.next(),f=!1;"("===a&&(f=!0,a=this.tn.next());if(!d.TYPEREF.test(a))throw Error("illegal option name: "+a);var e=a;f&&(this.tn.skip(")"),e="("+e+")",a=this.tn.peek(),d.FQTYPEREF.test(a)&&(e+=a,this.tn.next()));this.tn.skip("=");this._parseOptionValue(b,e);c||this.tn.skip(";")};e._parseOptionValue=function(b,c){var a=this.tn.peek();if("{"!==a)n(b.options,c,this._readValue(!0));else for(this.tn.skip("{");"}"!==(a=this.tn.next());){if(!d.NAME.test(a))throw Error("illegal option name: "+
c+"."+a);this.tn.omit(":")?n(b.options,c+"."+a,this._readValue(!0)):this._parseOptionValue(b,c+"."+a)}};e._parseService=function(b){var c=this.tn.next();if(!d.NAME.test(c))throw Error("illegal service name at line "+this.tn.line+": "+c);var a={name:c,rpc:{},options:{}};for(this.tn.skip("{");"}"!==(c=this.tn.next());)if("option"===c)this._parseOption(a);else if("rpc"===c)this._parseServiceRPC(a);else throw Error("illegal service token: "+c);this.tn.omit(";");b.services.push(a)};e._parseServiceRPC=
function(b){var c=this.tn.next();if(!d.NAME.test(c))throw Error("illegal rpc service method name: "+c);var a=c,f={request:null,response:null,request_stream:!1,response_stream:!1,options:{}};this.tn.skip("(");c=this.tn.next();"stream"===c.toLowerCase()&&(f.request_stream=!0,c=this.tn.next());if(!d.TYPEREF.test(c))throw Error("illegal rpc service request type: "+c);f.request=c;this.tn.skip(")");c=this.tn.next();if("returns"!==c.toLowerCase())throw Error("illegal rpc service request type delimiter: "+
c);this.tn.skip("(");c=this.tn.next();"stream"===c.toLowerCase()&&(f.response_stream=!0,c=this.tn.next());f.response=c;this.tn.skip(")");c=this.tn.peek();if("{"===c){for(this.tn.next();"}"!==(c=this.tn.next());)if("option"===c)this._parseOption(f);else throw Error("illegal rpc service token: "+c);this.tn.omit(";")}else this.tn.skip(";");"undefined"===typeof b.rpc&&(b.rpc={});b.rpc[a]=f};e._parseMessage=function(b,c){var a=!!c,f=this.tn.next(),e={name:"",fields:[],enums:[],messages:[],options:{},oneofs:{}};
if(!d.NAME.test(f))throw Error("illegal "+(a?"group":"message")+" name: "+f);e.name=f;a&&(this.tn.skip("="),c.id=h(this.tn.next()),e.isGroup=!0);f=this.tn.peek();"["===f&&c&&this._parseFieldOptions(c);for(this.tn.skip("{");"}"!==(f=this.tn.next());)if(d.RULE.test(f))this._parseMessageField(e,f);else if("oneof"===f)this._parseMessageOneOf(e);else if("enum"===f)this._parseEnum(e);else if("message"===f)this._parseMessage(e);else if("option"===f)this._parseOption(e);else if("extensions"===f)this._parseExtensions(e);
else if("extend"===f)this._parseExtend(e);else if(d.TYPEREF.test(f)){if(!this.proto3)throw Error("illegal field rule: "+f);this._parseMessageField(e,"optional",f)}else throw Error("illegal message token: "+f);this.tn.omit(";");b.messages.push(e);return e};e._parseMessageField=function(b,c,a){if(!d.RULE.test(c))throw Error("illegal message field rule: "+c);var f={rule:c,type:"",name:"",options:{},id:0};if("map"===c){if(a)throw Error("illegal type: "+a);this.tn.skip("<");c=this.tn.next();if(!d.TYPE.test(c)&&
!d.TYPEREF.test(c))throw Error("illegal message field type: "+c);f.keytype=c;this.tn.skip(",");c=this.tn.next();if(!d.TYPE.test(c)&&!d.TYPEREF.test(c))throw Error("illegal message field: "+c);f.type=c;this.tn.skip(">");c=this.tn.next();if(!d.NAME.test(c))throw Error("illegal message field name: "+c);f.name=c;this.tn.skip("=");f.id=h(this.tn.next());c=this.tn.peek();"["===c&&this._parseFieldOptions(f);this.tn.skip(";")}else if(a="undefined"!==typeof a?a:this.tn.next(),"group"===a){c=this._parseMessage(b,
f);if(!/^[A-Z]/.test(c.name))throw Error("illegal group name: "+c.name);f.type=c.name;f.name=c.name.toLowerCase();this.tn.omit(";")}else{if(!d.TYPE.test(a)&&!d.TYPEREF.test(a))throw Error("illegal message field type: "+a);f.type=a;c=this.tn.next();if(!d.NAME.test(c))throw Error("illegal message field name: "+c);f.name=c;this.tn.skip("=");f.id=h(this.tn.next());c=this.tn.peek();"["===c&&this._parseFieldOptions(f);this.tn.skip(";")}b.fields.push(f);return f};e._parseMessageOneOf=function(b){var c=this.tn.next();
if(!d.NAME.test(c))throw Error("illegal oneof name: "+c);var a=c,f=[];for(this.tn.skip("{");"}"!==(c=this.tn.next());)c=this._parseMessageField(b,"optional",c),c.oneof=a,f.push(c.id);this.tn.omit(";");b.oneofs[a]=f};e._parseFieldOptions=function(b){this.tn.skip("[");for(var c=!0;"]"!==this.tn.peek();)c||this.tn.skip(","),this._parseOption(b,!0),c=!1;this.tn.next()};e._parseEnum=function(b){var c={name:"",values:[],options:{}},a=this.tn.next();if(!d.NAME.test(a))throw Error("illegal name: "+a);c.name=
a;for(this.tn.skip("{");"}"!==(a=this.tn.next());)if("option"===a)this._parseOption(c);else{if(!d.NAME.test(a))throw Error("illegal name: "+a);this.tn.skip("=");var f={name:a,id:h(this.tn.next(),!0)},a=this.tn.peek();"["===a&&this._parseFieldOptions({options:{}});this.tn.skip(";");c.values.push(f)}this.tn.omit(";");b.enums.push(c)};e._parseExtensions=function(a){var c=this.tn.next(),d=[];"min"===c?d.push(b.ID_MIN):"max"===c?d.push(b.ID_MAX):d.push(q(c));this.tn.skip("to");c=this.tn.next();"min"===
c?d.push(b.ID_MIN):"max"===c?d.push(b.ID_MAX):d.push(q(c));this.tn.skip(";");a.extensions=d};e._parseExtend=function(b){var a=this.tn.next();if(!d.TYPEREF.test(a))throw Error("illegal extend reference: "+a);var e={ref:a,fields:[]};for(this.tn.skip("{");"}"!==(a=this.tn.next());)if(d.RULE.test(a))this._parseMessageField(e,a);else if(d.TYPEREF.test(a)){if(!this.proto3)throw Error("illegal field rule: "+a);this._parseMessageField(e,"optional",a)}else throw Error("illegal extend token: "+a);this.tn.omit(";");
b.messages.push(e);return e};e.toString=function(){return"Parser at line "+this.tn.line};k.Parser=g;return k}(d,d.Lang);d.Reflect=function(b){function d(l,m){if(l&&"number"===typeof l.low&&"number"===typeof l.high&&"boolean"===typeof l.unsigned&&l.low===l.low&&l.high===l.high)return new b.Long(l.low,l.high,"undefined"===typeof m?l.unsigned:m);if("string"===typeof l)return b.Long.fromString(l,m||!1,10);if("number"===typeof l)return b.Long.fromNumber(l,m||!1);throw Error("not convertible to Long");
}function p(l,m){var a=m.readVarint32(),c=a&7,a=a>>>3;switch(c){case b.WIRE_TYPES.VARINT:do a=m.readUint8();while(128===(a&128));break;case b.WIRE_TYPES.BITS64:m.offset+=8;break;case b.WIRE_TYPES.LDELIM:a=m.readVarint32();m.offset+=a;break;case b.WIRE_TYPES.STARTGROUP:p(a,m);break;case b.WIRE_TYPES.ENDGROUP:if(a===l)return!1;throw Error("Illegal GROUPEND after unknown group: "+a+" ("+l+" expected)");case b.WIRE_TYPES.BITS32:m.offset+=4;break;default:throw Error("Illegal wire type in unknown group "+
l+": "+c);}return!0}var q={},n=function(b,m,a){this.builder=b;this.parent=m;this.name=a},k=n.prototype;k.fqn=function(){var b=this.name,m=this;do{m=m.parent;if(null==m)break;b=m.name+"."+b}while(1);return b};k.toString=function(b){return(b?this.className+" ":"")+this.fqn()};k.build=function(){throw Error(this.toString(!0)+" cannot be built directly");};q.T=n;var a=function(b,m,a,c,d){n.call(this,b,m,a);this.className="Namespace";this.children=[];this.options=c||{};this.syntax=d||"proto2"},k=a.prototype=
Object.create(n.prototype);k.getChildren=function(b){b=b||null;if(null==b)return this.children.slice();for(var m=[],a=0,c=this.children.length;a<c;++a)this.children[a]instanceof b&&m.push(this.children[a]);return m};k.addChild=function(b){var a;if(a=this.getChild(b.name))if(a instanceof s.Field&&a.name!==a.originalName&&null===this.getChild(a.originalName))a.name=a.originalName;else if(b instanceof s.Field&&b.name!==b.originalName&&null===this.getChild(b.originalName))b.name=b.originalName;else throw Error("Duplicate name in namespace "+
this.toString(!0)+": "+b.name);this.children.push(b)};k.getChild=function(b){for(var a="number"===typeof b?"id":"name",c=0,d=this.children.length;c<d;++c)if(this.children[c][a]===b)return this.children[c];return null};k.resolve=function(b,a){var c="string"===typeof b?b.split("."):b,d=this,e=0;if(""===c[e]){for(;null!==d.parent;)d=d.parent;e++}do{do{if(!(d instanceof q.Namespace)){d=null;break}d=d.getChild(c[e]);if(!(d&&d instanceof q.T)||a&&!(d instanceof q.Namespace)){d=null;break}e++}while(e<c.length);
if(null!=d)break;if(null!==this.parent)return this.parent.resolve(b,a)}while(null!=d);return d};k.qn=function(b){var a=[],c=b;do a.unshift(c.name),c=c.parent;while(null!==c);for(c=1;c<=a.length;c++){var d=a.slice(a.length-c);if(b===this.resolve(d,b instanceof q.Namespace))return d.join(".")}return b.fqn()};k.build=function(){for(var b={},m=this.children,c=0,d=m.length,e;c<d;++c)e=m[c],e instanceof a&&(b[e.name]=e.build());Object.defineProperty&&Object.defineProperty(b,"$options",{value:this.buildOpt()});
return b};k.buildOpt=function(){for(var b={},a=Object.keys(this.options),c=0,d=a.length;c<d;++c)b[a[c]]=this.options[a[c]];return b};k.getOption=function(b){return"undefined"===typeof b?this.options:"undefined"!==typeof this.options[b]?this.options[b]:null};q.Namespace=a;var e=function(l,a,c,d){this.type=l;this.resolvedType=a;this.isMapKey=c;this.syntax=d;if(c&&0>b.MAP_KEY_TYPES.indexOf(l))throw Error("Invalid map key type: "+l.name);},g=e.prototype;e.defaultFieldValue=function(l){"string"===typeof l&&
(l=b.TYPES[l]);if("undefined"===typeof l.defaultValue)throw Error("default value for type "+l.name+" is not supported");return l==b.TYPES.bytes?new h(0):l.defaultValue};g.verifyValue=function(l){var a=function(b,l){throw Error("Illegal value for "+this.toString(!0)+" of type "+this.type.name+": "+b+" ("+l+")");}.bind(this);switch(this.type){case b.TYPES.int32:case b.TYPES.sint32:case b.TYPES.sfixed32:return("number"!==typeof l||l===l&&0!==l%1)&&a(typeof l,"not an integer"),4294967295<l?l|0:l;case b.TYPES.uint32:case b.TYPES.fixed32:return("number"!==
typeof l||l===l&&0!==l%1)&&a(typeof l,"not an integer"),0>l?l>>>0:l;case b.TYPES.int64:case b.TYPES.sint64:case b.TYPES.sfixed64:if(b.Long)try{return d(l,!1)}catch(c){a(typeof l,c.message)}else a(typeof l,"requires Long.js");case b.TYPES.uint64:case b.TYPES.fixed64:if(b.Long)try{return d(l,!0)}catch(e){a(typeof l,e.message)}else a(typeof l,"requires Long.js");case b.TYPES.bool:return"boolean"!==typeof l&&a(typeof l,"not a boolean"),l;case b.TYPES["float"]:case b.TYPES["double"]:return"number"!==typeof l&&
a(typeof l,"not a number"),l;case b.TYPES.string:return"string"===typeof l||l&&l instanceof String||a(typeof l,"not a string"),""+l;case b.TYPES.bytes:return h.isByteBuffer(l)?l:h.wrap(l,"base64");case b.TYPES["enum"]:for(var f=this.resolvedType.getChildren(b.Reflect.Enum.Value),g=0;g<f.length;g++)if(f[g].name==l||f[g].id==l)return f[g].id;if("proto3"===this.syntax)return("number"!==typeof l||l===l&&0!==l%1)&&a(typeof l,"not an integer"),(4294967295<l||0>l)&&a(typeof l,"not in range for uint32"),
l;a(l,"not a valid enum value");case b.TYPES.group:case b.TYPES.message:l&&"object"===typeof l||a(typeof l,"object expected");if(l instanceof this.resolvedType.clazz)return l;if(l instanceof b.Builder.Message){var a={},g;for(g in l)l.hasOwnProperty(g)&&(a[g]=l[g]);l=a}return new this.resolvedType.clazz(l)}throw Error("[INTERNAL] Illegal value for "+this.toString(!0)+": "+l+" (undefined type "+this.type+")");};g.calculateLength=function(l,a){if(null===a)return 0;var c;switch(this.type){case b.TYPES.int32:return 0>
a?h.calculateVarint64(a):h.calculateVarint32(a);case b.TYPES.uint32:return h.calculateVarint32(a);case b.TYPES.sint32:return h.calculateVarint32(h.zigZagEncode32(a));case b.TYPES.fixed32:case b.TYPES.sfixed32:case b.TYPES["float"]:return 4;case b.TYPES.int64:case b.TYPES.uint64:return h.calculateVarint64(a);case b.TYPES.sint64:return h.calculateVarint64(h.zigZagEncode64(a));case b.TYPES.fixed64:case b.TYPES.sfixed64:return 8;case b.TYPES.bool:return 1;case b.TYPES["enum"]:return h.calculateVarint32(a);
case b.TYPES["double"]:return 8;case b.TYPES.string:return c=h.calculateUTF8Bytes(a),h.calculateVarint32(c)+c;case b.TYPES.bytes:if(0>a.remaining())throw Error("Illegal value for "+this.toString(!0)+": "+a.remaining()+" bytes remaining");return h.calculateVarint32(a.remaining())+a.remaining();case b.TYPES.message:return c=this.resolvedType.calculate(a),h.calculateVarint32(c)+c;case b.TYPES.group:return c=this.resolvedType.calculate(a),c+h.calculateVarint32(l<<3|b.WIRE_TYPES.ENDGROUP)}throw Error("[INTERNAL] Illegal value to encode in "+
this.toString(!0)+": "+a+" (unknown type)");};g.encodeValue=function(a,c,d){if(null===c)return d;switch(this.type){case b.TYPES.int32:0>c?d.writeVarint64(c):d.writeVarint32(c);break;case b.TYPES.uint32:d.writeVarint32(c);break;case b.TYPES.sint32:d.writeVarint32ZigZag(c);break;case b.TYPES.fixed32:d.writeUint32(c);break;case b.TYPES.sfixed32:d.writeInt32(c);break;case b.TYPES.int64:case b.TYPES.uint64:d.writeVarint64(c);break;case b.TYPES.sint64:d.writeVarint64ZigZag(c);break;case b.TYPES.fixed64:d.writeUint64(c);
break;case b.TYPES.sfixed64:d.writeInt64(c);break;case b.TYPES.bool:"string"===typeof c?d.writeVarint32("false"===c.toLowerCase()?0:!!c):d.writeVarint32(c?1:0);break;case b.TYPES["enum"]:d.writeVarint32(c);break;case b.TYPES["float"]:d.writeFloat32(c);break;case b.TYPES["double"]:d.writeFloat64(c);break;case b.TYPES.string:d.writeVString(c);break;case b.TYPES.bytes:if(0>c.remaining())throw Error("Illegal value for "+this.toString(!0)+": "+c.remaining()+" bytes remaining");a=c.offset;d.writeVarint32(c.remaining());
d.append(c);c.offset=a;break;case b.TYPES.message:a=(new h).LE();this.resolvedType.encode(c,a);d.writeVarint32(a.offset);d.append(a.flip());break;case b.TYPES.group:this.resolvedType.encode(c,d);d.writeVarint32(a<<3|b.WIRE_TYPES.ENDGROUP);break;default:throw Error("[INTERNAL] Illegal value to encode in "+this.toString(!0)+": "+c+" (unknown type)");}return d};g.decode=function(a,c,d){if(c!=this.type.wireType)throw Error("Unexpected wire type for element");switch(this.type){case b.TYPES.int32:return a.readVarint32()|
0;case b.TYPES.uint32:return a.readVarint32()>>>0;case b.TYPES.sint32:return a.readVarint32ZigZag()|0;case b.TYPES.fixed32:return a.readUint32()>>>0;case b.TYPES.sfixed32:return a.readInt32()|0;case b.TYPES.int64:return a.readVarint64();case b.TYPES.uint64:return a.readVarint64().toUnsigned();case b.TYPES.sint64:return a.readVarint64ZigZag();case b.TYPES.fixed64:return a.readUint64();case b.TYPES.sfixed64:return a.readInt64();case b.TYPES.bool:return!!a.readVarint32();case b.TYPES["enum"]:return a.readVarint32();
case b.TYPES["float"]:return a.readFloat();case b.TYPES["double"]:return a.readDouble();case b.TYPES.string:return a.readVString();case b.TYPES.bytes:d=a.readVarint32();if(a.remaining()<d)throw Error("Illegal number of bytes for "+this.toString(!0)+": "+d+" required but got only "+a.remaining());c=a.clone();c.limit=c.offset+d;a.offset+=d;return c;case b.TYPES.message:return d=a.readVarint32(),this.resolvedType.decode(a,d);case b.TYPES.group:return this.resolvedType.decode(a,-1,d)}throw Error("[INTERNAL] Illegal decode type");
};g.valueFromString=function(a){if(!this.isMapKey)throw Error("valueFromString() called on non-map-key element");switch(this.type){case b.TYPES.int32:case b.TYPES.sint32:case b.TYPES.sfixed32:case b.TYPES.uint32:case b.TYPES.fixed32:return this.verifyValue(parseInt(a));case b.TYPES.int64:case b.TYPES.sint64:case b.TYPES.sfixed64:case b.TYPES.uint64:case b.TYPES.fixed64:return this.verifyValue(a);case b.TYPES.bool:return"true"===a;case b.TYPES.string:return this.verifyValue(a);case b.TYPES.bytes:return h.fromBinary(a)}};
g.valueToString=function(a){if(!this.isMapKey)throw Error("valueToString() called on non-map-key element");return this.type===b.TYPES.bytes?a.toString("binary"):a.toString()};q.Element=e;var s=function(c,d,e,f,g,k){a.call(this,c,d,e,f,k);this.className="Message";this.extensions=[b.ID_MIN,b.ID_MAX];this.clazz=null;this.isGroup=!!g;this._fieldsByName=this._fieldsById=this._fields=null},g=s.prototype=Object.create(a.prototype);g.build=function(a){if(this.clazz&&!a)return this.clazz;a=function(b,a){function c(a,
d,l,e){if(null===a||"object"!==typeof a){if(e&&e instanceof b.Reflect.Enum){var f=b.Reflect.Enum.getName(e.object,a);if(null!==f)return f}return a}if(h.isByteBuffer(a))return d?a.toBase64():a.toBuffer();if(b.Long.isLong(a))return l?a.toString():new b.Long(a);var m;if(Array.isArray(a))return m=[],a.forEach(function(b,a){m[a]=c(b,d,l,e)}),m;m={};if(a instanceof b.Map){for(var f=a.entries(),g=f.next();!g.done;g=f.next())m[a.keyElem.valueToString(g.value[0])]=c(g.value[1],d,l,a.valueElem.resolvedType);
return m}var f=a.$type,g=void 0,k;for(k in a)a.hasOwnProperty(k)&&(f&&(g=f.getChild(k))?m[k]=c(a[k],d,l,g.resolvedType):m[k]=c(a[k],d,l));return m}var d=a.getChildren(b.Reflect.Message.Field),l=a.getChildren(b.Reflect.Message.OneOf),e=function(c,f){b.Builder.Message.call(this);for(var m=0,g=l.length;m<g;++m)this[l[m].name]=null;m=0;for(g=d.length;m<g;++m){var k=d[m];this[k.name]=k.repeated?[]:k.map?new b.Map(k):null;!k.required&&"proto3"!==a.syntax||null===k.defaultValue||(this[k.name]=k.defaultValue)}if(0<
arguments.length)if(1!==arguments.length||null===c||"object"!==typeof c||!("function"!==typeof c.encode||c instanceof e)||Array.isArray(c)||c instanceof b.Map||h.isByteBuffer(c)||c instanceof ArrayBuffer||b.Long&&c instanceof b.Long)for(m=0,g=arguments.length;m<g;++m)"undefined"!==typeof(k=arguments[m])&&this.$set(d[m].name,k);else this.$set(c)},f=e.prototype=Object.create(b.Builder.Message.prototype);f.add=function(c,d,l){var e=a._fieldsByName[c];if(!l){if(!e)throw Error(this+"#"+c+" is undefined");
if(!(e instanceof b.Reflect.Message.Field))throw Error(this+"#"+c+" is not a field: "+e.toString(!0));if(!e.repeated)throw Error(this+"#"+c+" is not a repeated field");d=e.verifyValue(d,!0)}null===this[c]&&(this[c]=[]);this[c].push(d);return this};f.$add=f.add;f.set=function(c,d,l){if(c&&"object"===typeof c){l=d;for(var e in c)c.hasOwnProperty(e)&&"undefined"!==typeof(d=c[e])&&this.$set(e,d,l);return this}e=a._fieldsByName[c];if(l)this[c]=d;else{if(!e)throw Error(this+"#"+c+" is not a field: undefined");
if(!(e instanceof b.Reflect.Message.Field))throw Error(this+"#"+c+" is not a field: "+e.toString(!0));this[e.name]=d=e.verifyValue(d)}e&&e.oneof&&(l=this[e.oneof.name],null!==d?(null!==l&&l!==e.name&&(this[l]=null),this[e.oneof.name]=e.name):l===c&&(this[e.oneof.name]=null));return this};f.$set=f.set;f.get=function(c,d){if(d)return this[c];var l=a._fieldsByName[c];if(!(l&&l instanceof b.Reflect.Message.Field))throw Error(this+"#"+c+" is not a field: undefined");if(!(l instanceof b.Reflect.Message.Field))throw Error(this+
"#"+c+" is not a field: "+l.toString(!0));return this[l.name]};f.$get=f.get;for(var m=0;m<d.length;m++){var g=d[m];g instanceof b.Reflect.Message.ExtensionField||a.builder.options.populateAccessors&&function(b){var c=b.originalName.replace(/(_[a-zA-Z])/g,function(b){return b.toUpperCase().replace("_","")}),c=c.substring(0,1).toUpperCase()+c.substring(1),d=b.originalName.replace(/([A-Z])/g,function(b){return"_"+b}),l=function(a,c){this[b.name]=c?a:b.verifyValue(a);return this},e=function(){return this[b.name]};
null===a.getChild("set"+c)&&(f["set"+c]=l);null===a.getChild("set_"+d)&&(f["set_"+d]=l);null===a.getChild("get"+c)&&(f["get"+c]=e);null===a.getChild("get_"+d)&&(f["get_"+d]=e)}(g)}f.encode=function(b,c){"boolean"===typeof b&&(c=b,b=void 0);var d=!1;b||(b=new h,d=!0);var l=b.littleEndian;try{return a.encode(this,b.LE(),c),(d?b.flip():b).LE(l)}catch(e){throw b.LE(l),e;}};e.encode=function(b,a,c){return(new e(b)).encode(a,c)};f.calculate=function(){return a.calculate(this)};f.encodeDelimited=function(b){var c=
!1;b||(b=new h,c=!0);var d=(new h).LE();a.encode(this,d).flip();b.writeVarint32(d.remaining());b.append(d);return c?b.flip():b};f.encodeAB=function(){try{return this.encode().toArrayBuffer()}catch(b){throw b.encoded&&(b.encoded=b.encoded.toArrayBuffer()),b;}};f.toArrayBuffer=f.encodeAB;f.encodeNB=function(){try{return this.encode().toBuffer()}catch(b){throw b.encoded&&(b.encoded=b.encoded.toBuffer()),b;}};f.toBuffer=f.encodeNB;f.encode64=function(){try{return this.encode().toBase64()}catch(b){throw b.encoded&&
(b.encoded=b.encoded.toBase64()),b;}};f.toBase64=f.encode64;f.encodeHex=function(){try{return this.encode().toHex()}catch(b){throw b.encoded&&(b.encoded=b.encoded.toHex()),b;}};f.toHex=f.encodeHex;f.toRaw=function(b,a){return c(this,!!b,!!a,this.$type)};f.encodeJSON=function(){return JSON.stringify(c(this,!0,!0,this.$type))};e.decode=function(b,c){"string"===typeof b&&(b=h.wrap(b,c?c:"base64"));b=h.isByteBuffer(b)?b:h.wrap(b);var d=b.littleEndian;try{var l=a.decode(b.LE());b.LE(d);return l}catch(e){throw b.LE(d),
e;}};e.decodeDelimited=function(b,c){"string"===typeof b&&(b=h.wrap(b,c?c:"base64"));b=h.isByteBuffer(b)?b:h.wrap(b);if(1>b.remaining())return null;var d=b.offset,l=b.readVarint32();if(b.remaining()<l)return b.offset=d,null;try{var e=a.decode(b.slice(b.offset,b.offset+l).LE());b.offset+=l;return e}catch(f){throw b.offset+=l,f;}};e.decode64=function(b){return e.decode(b,"base64")};e.decodeHex=function(b){return e.decode(b,"hex")};e.decodeJSON=function(b){return new e(JSON.parse(b))};f.toString=function(){return a.toString()};
Object.defineProperty&&(Object.defineProperty(e,"$options",{value:a.buildOpt()}),Object.defineProperty(f,"$options",{value:e.$options}),Object.defineProperty(e,"$type",{value:a}),Object.defineProperty(f,"$type",{value:a}));return e}(b,this);this._fields=[];this._fieldsById={};this._fieldsByName={};for(var c=0,d=this.children.length,e;c<d;c++)if(e=this.children[c],e instanceof t||e instanceof s||e instanceof w){if(a.hasOwnProperty(e.name))throw Error("Illegal reflect child of "+this.toString(!0)+": "+
e.toString(!0)+" cannot override static property '"+e.name+"'");a[e.name]=e.build()}else if(e instanceof s.Field)e.build(),this._fields.push(e),this._fieldsById[e.id]=e,this._fieldsByName[e.name]=e;else if(!(e instanceof s.OneOf||e instanceof f))throw Error("Illegal reflect child of "+this.toString(!0)+": "+this.children[c].toString(!0));return this.clazz=a};g.encode=function(b,a,c){for(var d=null,e,f=0,g=this._fields.length,k;f<g;++f)e=this._fields[f],k=b[e.name],e.required&&null===k?null===d&&(d=
e):e.encode(c?k:e.verifyValue(k),a,b);if(null!==d)throw b=Error("Missing at least one required field for "+this.toString(!0)+": "+d),b.encoded=a,b;return a};g.calculate=function(b){for(var a=0,c=0,d=this._fields.length,e,f;c<d;++c){e=this._fields[c];f=b[e.name];if(e.required&&null===f)throw Error("Missing at least one required field for "+this.toString(!0)+": "+e);a+=e.calculate(f,b)}return a};g.decode=function(a,c,d){c="number"===typeof c?c:-1;for(var e=a.offset,f=new this.clazz,g,k,s;a.offset<e+
c||-1===c&&0<a.remaining();){g=a.readVarint32();k=g&7;s=g>>>3;if(k===b.WIRE_TYPES.ENDGROUP){if(s!==d)throw Error("Illegal group end indicator for "+this.toString(!0)+": "+s+" ("+(d?d+" expected":"not a group")+")");break}if(g=this._fieldsById[s])g.repeated&&!g.options.packed?f[g.name].push(g.decode(k,a)):g.map?(k=g.decode(k,a),f[g.name].set(k[0],k[1])):(f[g.name]=g.decode(k,a),g.oneof&&(k=f[g.oneof.name],null!==k&&k!==g.name&&(f[k]=null),f[g.oneof.name]=g.name));else switch(k){case b.WIRE_TYPES.VARINT:a.readVarint32();
break;case b.WIRE_TYPES.BITS32:a.offset+=4;break;case b.WIRE_TYPES.BITS64:a.offset+=8;break;case b.WIRE_TYPES.LDELIM:g=a.readVarint32();a.offset+=g;break;case b.WIRE_TYPES.STARTGROUP:for(;p(s,a););break;default:throw Error("Illegal wire type for unknown field "+s+" in "+this.toString(!0)+"#decode: "+k);}}a=0;for(c=this._fields.length;a<c;++a)if(g=this._fields[a],null===f[g.name])if("proto3"===this.syntax)f[g.name]=g.defaultValue;else{if(g.required)throw a=Error("Missing at least one required field for "+
this.toString(!0)+": "+g.name),a.decoded=f,a;b.populateDefaults&&null!==g.defaultValue&&(f[g.name]=g.defaultValue)}return f};q.Message=s;var c=function(a,c,d,e,f,g,k,h,r,p){n.call(this,a,c,g);this.className="Message.Field";this.required="required"===d;this.repeated="repeated"===d;this.map="map"===d;this.keyType=e||null;this.type=f;this.resolvedType=null;this.id=k;this.options=h||{};this.defaultValue=null;this.oneof=r||null;this.syntax=p||"proto2";this.originalName=this.name;this.keyElement=this.element=
null;!this.builder.options.convertFieldsToCamelCase||this instanceof s.ExtensionField||(this.name=b.Util.toCamelCase(this.name))},g=c.prototype=Object.create(n.prototype);g.build=function(){this.element=new e(this.type,this.resolvedType,!1,this.syntax);this.map&&(this.keyElement=new e(this.keyType,void 0,!0,this.syntax));"proto3"!==this.syntax||this.repeated||this.map?"undefined"!==typeof this.options["default"]&&(this.defaultValue=this.verifyValue(this.options["default"])):this.defaultValue=e.defaultFieldValue(this.type)};
g.verifyValue=function(a,c){c=c||!1;var d=function(b,a){throw Error("Illegal value for "+this.toString(!0)+" of type "+this.type.name+": "+b+" ("+a+")");}.bind(this);if(null===a)return this.required&&d(typeof a,"required"),"proto3"===this.syntax&&this.type!==b.TYPES.message&&d(typeof a,"proto3 field without field presence cannot be null"),null;if(this.repeated&&!c){Array.isArray(a)||(a=[a]);for(var e=[],d=0;d<a.length;d++)e.push(this.element.verifyValue(a[d]));return e}if(this.map&&!c){if(a instanceof
b.Map)return a;a instanceof Object||d(typeof a,"expected ProtoBuf.Map or raw object for map field");return new b.Map(this,a)}!this.repeated&&Array.isArray(a)&&d(typeof a,"no array expected");return this.element.verifyValue(a)};g.hasWirePresence=function(a,c){if("proto3"!==this.syntax)return null!==a;if(this.oneof&&c[this.oneof.name]===this.name)return!0;switch(this.type){case b.TYPES.int32:case b.TYPES.sint32:case b.TYPES.sfixed32:case b.TYPES.uint32:case b.TYPES.fixed32:return 0!==a;case b.TYPES.int64:case b.TYPES.sint64:case b.TYPES.sfixed64:case b.TYPES.uint64:case b.TYPES.fixed64:return 0!==
a.low||0!==a.high;case b.TYPES.bool:return a;case b.TYPES["float"]:case b.TYPES["double"]:return 0!==a;case b.TYPES.string:return 0<a.length;case b.TYPES.bytes:return 0<a.remaining();case b.TYPES["enum"]:return 0!==a;case b.TYPES.message:return null!==a;default:return!0}};g.encode=function(a,c,d){if(null===this.type||"object"!==typeof this.type)throw Error("[INTERNAL] Unresolved type in "+this.toString(!0)+": "+this.type);if(null===a||this.repeated&&0==a.length)return c;try{if(this.repeated){var e;
if(this.options.packed&&0<=b.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType)){c.writeVarint32(this.id<<3|b.WIRE_TYPES.LDELIM);c.ensureCapacity(c.offset+=1);var f=c.offset;for(e=0;e<a.length;e++)this.element.encodeValue(this.id,a[e],c);var g=c.offset-f,k=h.calculateVarint32(g);if(1<k){var s=c.slice(f,c.offset),f=f+(k-1);c.offset=f;c.append(s)}c.writeVarint32(g,f-k)}else for(e=0;e<a.length;e++)c.writeVarint32(this.id<<3|this.type.wireType),this.element.encodeValue(this.id,a[e],c)}else this.map?a.forEach(function(a,
d,e){e=h.calculateVarint32(8|this.keyType.wireType)+this.keyElement.calculateLength(1,d)+h.calculateVarint32(16|this.type.wireType)+this.element.calculateLength(2,a);c.writeVarint32(this.id<<3|b.WIRE_TYPES.LDELIM);c.writeVarint32(e);c.writeVarint32(8|this.keyType.wireType);this.keyElement.encodeValue(1,d,c);c.writeVarint32(16|this.type.wireType);this.element.encodeValue(2,a,c)},this):this.hasWirePresence(a,d)&&(c.writeVarint32(this.id<<3|this.type.wireType),this.element.encodeValue(this.id,a,c))}catch(r){throw Error("Illegal value for "+
this.toString(!0)+": "+a+" ("+r+")");}return c};g.calculate=function(a,c){a=this.verifyValue(a);if(null===this.type||"object"!==typeof this.type)throw Error("[INTERNAL] Unresolved type in "+this.toString(!0)+": "+this.type);if(null===a||this.repeated&&0==a.length)return 0;var d=0;try{if(this.repeated){var e,f;if(this.options.packed&&0<=b.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType)){d+=h.calculateVarint32(this.id<<3|b.WIRE_TYPES.LDELIM);for(e=f=0;e<a.length;e++)f+=this.element.calculateLength(this.id,
a[e]);d+=h.calculateVarint32(f);d+=f}else for(e=0;e<a.length;e++)d+=h.calculateVarint32(this.id<<3|this.type.wireType),d+=this.element.calculateLength(this.id,a[e])}else this.map?a.forEach(function(a,c,e){a=h.calculateVarint32(8|this.keyType.wireType)+this.keyElement.calculateLength(1,c)+h.calculateVarint32(16|this.type.wireType)+this.element.calculateLength(2,a);d+=h.calculateVarint32(this.id<<3|b.WIRE_TYPES.LDELIM);d+=h.calculateVarint32(a);d+=a},this):this.hasWirePresence(a,c)&&(d+=h.calculateVarint32(this.id<<
3|this.type.wireType),d+=this.element.calculateLength(this.id,a))}catch(g){throw Error("Illegal value for "+this.toString(!0)+": "+a+" ("+g+")");}return d};g.decode=function(a,c,d){if(!(!this.map&&a==this.type.wireType||!d&&this.repeated&&this.options.packed&&a==b.WIRE_TYPES.LDELIM||this.map&&a==b.WIRE_TYPES.LDELIM))throw Error("Illegal wire type for field "+this.toString(!0)+": "+a+" ("+this.type.wireType+" expected)");if(a==b.WIRE_TYPES.LDELIM&&this.repeated&&this.options.packed&&0<=b.PACKABLE_WIRE_TYPES.indexOf(this.type.wireType)&&
!d){a=c.readVarint32();a=c.offset+a;for(d=[];c.offset<a;)d.push(this.decode(this.type.wireType,c,!0));return d}if(this.map){var f=e.defaultFieldValue(this.keyType);d=e.defaultFieldValue(this.type);a=c.readVarint32();if(c.remaining()<a)throw Error("Illegal number of bytes for "+this.toString(!0)+": "+a+" required but got only "+c.remaining());var g=c.clone();g.limit=g.offset+a;for(c.offset+=a;0<g.remaining();)if(c=g.readVarint32(),a=c&7,c>>>=3,1===c)f=this.keyElement.decode(g,a,c);else if(2===c)d=
this.element.decode(g,a,c);else throw Error("Unexpected tag in map field key/value submessage");return[f,d]}return this.element.decode(c,a,this.id)};q.Message.Field=c;g=function(a,b,d,e,f,g,k){c.call(this,a,b,d,null,e,f,g,k)};g.prototype=Object.create(c.prototype);q.Message.ExtensionField=g;q.Message.OneOf=function(a,b,c){n.call(this,a,b,c);this.fields=[]};var t=function(b,c,d,e,f){a.call(this,b,c,d,e,f);this.className="Enum";this.object=null};t.getName=function(a,b){for(var c=Object.keys(a),d=0,
e;d<c.length;++d)if(a[e=c[d]]===b)return e;return null};(t.prototype=Object.create(a.prototype)).build=function(a){if(this.object&&!a)return this.object;a=new b.Builder.Enum;for(var c=this.getChildren(t.Value),d=0,e=c.length;d<e;++d)a[c[d].name]=c[d].id;Object.defineProperty&&Object.defineProperty(a,"$options",{value:this.buildOpt(),enumerable:!1});return this.object=a};q.Enum=t;g=function(a,b,c,d){n.call(this,a,b,c);this.className="Enum.Value";this.id=d};g.prototype=Object.create(n.prototype);q.Enum.Value=
g;var f=function(a,b,c,d){n.call(this,a,b,c);this.field=d};f.prototype=Object.create(n.prototype);q.Extension=f;var w=function(b,c,d,e){a.call(this,b,c,d,e);this.className="Service";this.clazz=null};(w.prototype=Object.create(a.prototype)).build=function(a){return this.clazz&&!a?this.clazz:this.clazz=function(a,b){for(var c=function(b){a.Builder.Service.call(this);this.rpcImpl=b||function(a,b,c){setTimeout(c.bind(this,Error("Not implemented, see: https://github.com/dcodeIO/ProtoBuf.js/wiki/Services")),
0)}},d=c.prototype=Object.create(a.Builder.Service.prototype),e=b.getChildren(a.Reflect.Service.RPCMethod),f=0;f<e.length;f++)(function(a){d[a.name]=function(c,d){try{try{c=a.resolvedRequestType.clazz.decode(h.wrap(c))}catch(e){if(!(e instanceof TypeError))throw e;}if(null===c||"object"!==typeof c)throw Error("Illegal arguments");c instanceof a.resolvedRequestType.clazz||(c=new a.resolvedRequestType.clazz(c));this.rpcImpl(a.fqn(),c,function(c,e){if(c)d(c);else{try{e=a.resolvedResponseType.clazz.decode(e)}catch(f){}e&&
e instanceof a.resolvedResponseType.clazz?d(null,e):d(Error("Illegal response type received in service method "+b.name+"#"+a.name))}})}catch(f){setTimeout(d.bind(this,f),0)}};c[a.name]=function(b,d,e){(new c(b))[a.name](d,e)};Object.defineProperty&&(Object.defineProperty(c[a.name],"$options",{value:a.buildOpt()}),Object.defineProperty(d[a.name],"$options",{value:c[a.name].$options}))})(e[f]);Object.defineProperty&&(Object.defineProperty(c,"$options",{value:b.buildOpt()}),Object.defineProperty(d,"$options",
{value:c.$options}),Object.defineProperty(c,"$type",{value:b}),Object.defineProperty(d,"$type",{value:b}));return c}(b,this)};q.Service=w;var v=function(a,b,c,d){n.call(this,a,b,c);this.className="Service.Method";this.options=d||{}};(v.prototype=Object.create(n.prototype)).buildOpt=k.buildOpt;q.Service.Method=v;k=function(a,b,c,d,e,f,g,k){v.call(this,a,b,c,k);this.className="Service.RPCMethod";this.requestName=d;this.responseName=e;this.requestStream=f;this.responseStream=g;this.resolvedResponseType=
this.resolvedRequestType=null};k.prototype=Object.create(v.prototype);q.Service.RPCMethod=k;return q}(d);d.Builder=function(b,d,h){function q(a){a.messages&&a.messages.forEach(function(b){b.syntax=a.syntax;q(b)});a.enums&&a.enums.forEach(function(b){b.syntax=a.syntax})}var n=function(a){this.ptr=this.ns=new h.Namespace(this,null,"");this.resolved=!1;this.result=null;this.files={};this.importRoot=null;this.options=a||{}},k=n.prototype;n.isMessage=function(a){return"string"!==typeof a.name||"undefined"!==
typeof a.values||"undefined"!==typeof a.rpc?!1:!0};n.isMessageField=function(a){return"string"!==typeof a.rule||"string"!==typeof a.name||"string"!==typeof a.type||"undefined"===typeof a.id?!1:!0};n.isEnum=function(a){return"string"===typeof a.name&&"undefined"!==typeof a.values&&Array.isArray(a.values)&&0!==a.values.length?!0:!1};n.isService=function(a){return"string"===typeof a.name&&"object"===typeof a.rpc&&a.rpc?!0:!1};n.isExtend=function(a){return"string"!==typeof a.ref?!1:!0};k.reset=function(){this.ptr=
this.ns;return this};k.define=function(a){if("string"!==typeof a||!d.TYPEREF.test(a))throw Error("illegal namespace: "+a);a.split(".").forEach(function(a){var b=this.ptr.getChild(a);null===b&&this.ptr.addChild(b=new h.Namespace(this,this.ptr,a));this.ptr=b},this);return this};k.create=function(a){if(!a)return this;if(Array.isArray(a)){if(0===a.length)return this;a=a.slice()}else a=[a];for(var d=[a];0<d.length;){a=d.pop();if(!Array.isArray(a))throw Error("not a valid namespace: "+JSON.stringify(a));
for(;0<a.length;){var g=a.shift();if(n.isMessage(g)){var k=new h.Message(this,this.ptr,g.name,g.options,g.isGroup,g.syntax),c={};g.oneofs&&Object.keys(g.oneofs).forEach(function(a){k.addChild(c[a]=new h.Message.OneOf(this,k,a))},this);g.fields&&g.fields.forEach(function(a){if(null!==k.getChild(a.id|0))throw Error("duplicate or invalid field id in "+k.name+": "+a.id);if(a.options&&"object"!==typeof a.options)throw Error("illegal field options in "+k.name+"#"+a.name);var b=null;if("string"===typeof a.oneof&&
!(b=c[a.oneof]))throw Error("illegal oneof in "+k.name+"#"+a.name+": "+a.oneof);a=new h.Message.Field(this,k,a.rule,a.keytype,a.type,a.name,a.id,a.options,b,g.syntax);b&&b.fields.push(a);k.addChild(a)},this);var r=[];g.enums&&g.enums.forEach(function(a){r.push(a)});g.messages&&g.messages.forEach(function(a){r.push(a)});g.services&&g.services.forEach(function(a){r.push(a)});g.extensions&&(k.extensions=g.extensions,k.extensions[0]<b.ID_MIN&&(k.extensions[0]=b.ID_MIN),k.extensions[1]>b.ID_MAX&&(k.extensions[1]=
b.ID_MAX));this.ptr.addChild(k);if(0<r.length){d.push(a);a=r;r=null;this.ptr=k;k=null;continue}r=null}else if(n.isEnum(g))k=new h.Enum(this,this.ptr,g.name,g.options,g.syntax),g.values.forEach(function(a){k.addChild(new h.Enum.Value(this,k,a.name,a.id))},this),this.ptr.addChild(k);else if(n.isService(g))k=new h.Service(this,this.ptr,g.name,g.options),Object.keys(g.rpc).forEach(function(a){var b=g.rpc[a];k.addChild(new h.Service.RPCMethod(this,k,a,b.request,b.response,!!b.request_stream,!!b.response_stream,
b.options))},this),this.ptr.addChild(k);else if(n.isExtend(g))if(k=this.ptr.resolve(g.ref,!0))g.fields.forEach(function(a){if(null!==k.getChild(a.id|0))throw Error("duplicate extended field id in "+k.name+": "+a.id);if(a.id<k.extensions[0]||a.id>k.extensions[1])throw Error("illegal extended field id in "+k.name+": "+a.id+" ("+k.extensions.join(" to ")+" expected)");var c=a.name;this.options.convertFieldsToCamelCase&&(c=b.Util.toCamelCase(c));c=new h.Message.ExtensionField(this,k,a.rule,a.type,this.ptr.fqn()+
"."+c,a.id,a.options);a=new h.Extension(this,this.ptr,a.name,c);c.extension=a;this.ptr.addChild(a);k.addChild(c)},this);else{if(!/\.?google\.protobuf\./.test(g.ref))throw Error("extended message "+g.ref+" is not defined");}else throw Error("not a valid definition: "+JSON.stringify(g));k=g=null}a=null;this.ptr=this.ptr.parent}this.resolved=!1;this.result=null;return this};k["import"]=function(a,d){var k="/";if("string"===typeof d){b.Util.IS_NODE&&(d=require("path").resolve(d));if(!0===this.files[d])return this.reset();
this.files[d]=!0}else if("object"===typeof d){var h=d.root;b.Util.IS_NODE&&(h=require("path").resolve(h));if(0<=h.indexOf("\\")||0<=d.file.indexOf("\\"))k="\\";h=h+k+d.file;if(!0===this.files[h])return this.reset();this.files[h]=!0}if(a.imports&&0<a.imports.length){var c=!1;if("object"===typeof d){if(this.importRoot=d.root,c=!0,h=this.importRoot,d=d.file,0<=h.indexOf("\\")||0<=d.indexOf("\\"))k="\\"}else"string"===typeof d?this.importRoot?h=this.importRoot:0<=d.indexOf("/")?(h=d.replace(/\/[^\/]*$/,
""),""===h&&(h="/")):0<=d.indexOf("\\")?(h=d.replace(/\\[^\\]*$/,""),k="\\"):h=".":h=null;for(var r=0;r<a.imports.length;r++)if("string"===typeof a.imports[r]){if(!h)throw Error("cannot determine import root");var f=a.imports[r];if("google/protobuf/descriptor.proto"!==f&&(f=h+k+f,!0!==this.files[f])){/\.proto$/i.test(f)&&!b.DotProto&&(f=f.replace(/\.proto$/,".json"));var n=b.Util.fetch(f);if(null===n)throw Error("failed to import '"+f+"' in '"+d+"': file not found");if(/\.json$/i.test(f))this["import"](JSON.parse(n+
""),f);else this["import"](b.DotProto.Parser.parse(n),f)}}else if(d)if(/\.(\w+)$/.test(d))this["import"](a.imports[r],d.replace(/^(.+)\.(\w+)$/,function(a,b,c){return b+"_import"+r+"."+c}));else this["import"](a.imports[r],d+"_import"+r);else this["import"](a.imports[r]);c&&(this.importRoot=null)}a["package"]&&this.define(a["package"]);a.syntax&&q(a);var p=this.ptr;a.options&&Object.keys(a.options).forEach(function(b){p.options[b]=a.options[b]});a.messages&&(this.create(a.messages),this.ptr=p);a.enums&&
(this.create(a.enums),this.ptr=p);a.services&&(this.create(a.services),this.ptr=p);a["extends"]&&this.create(a["extends"]);return this.reset()};k.resolveAll=function(){var a;if(null==this.ptr||"object"===typeof this.ptr.type)return this;if(this.ptr instanceof h.Namespace)this.ptr.children.forEach(function(a){this.ptr=a;this.resolveAll()},this);else if(this.ptr instanceof h.Message.Field){if(d.TYPE.test(this.ptr.type))this.ptr.type=b.TYPES[this.ptr.type];else{if(!d.TYPEREF.test(this.ptr.type))throw Error("illegal type reference in "+
this.ptr.toString(!0)+": "+this.ptr.type);a=(this.ptr instanceof h.Message.ExtensionField?this.ptr.extension.parent:this.ptr.parent).resolve(this.ptr.type,!0);if(!a)throw Error("unresolvable type reference in "+this.ptr.toString(!0)+": "+this.ptr.type);this.ptr.resolvedType=a;if(a instanceof h.Enum){if(this.ptr.type=b.TYPES["enum"],"proto3"===this.ptr.syntax&&"proto3"!==a.syntax)throw Error("proto3 message cannot reference proto2 enum");}else if(a instanceof h.Message)this.ptr.type=a.isGroup?b.TYPES.group:
b.TYPES.message;else throw Error("illegal type reference in "+this.ptr.toString(!0)+": "+this.ptr.type);}if(this.ptr.map){if(!d.TYPE.test(this.ptr.keyType))throw Error("illegal key type for map field in "+this.ptr.toString(!0)+": "+this.ptr.keyType);this.ptr.keyType=b.TYPES[this.ptr.keyType]}}else if(this.ptr instanceof b.Reflect.Service.Method)if(this.ptr instanceof b.Reflect.Service.RPCMethod){a=this.ptr.parent.resolve(this.ptr.requestName,!0);if(!(a&&a instanceof b.Reflect.Message))throw Error("Illegal type reference in "+
this.ptr.toString(!0)+": "+this.ptr.requestName);this.ptr.resolvedRequestType=a;a=this.ptr.parent.resolve(this.ptr.responseName,!0);if(!(a&&a instanceof b.Reflect.Message))throw Error("Illegal type reference in "+this.ptr.toString(!0)+": "+this.ptr.responseName);this.ptr.resolvedResponseType=a}else throw Error("illegal service type in "+this.ptr.toString(!0));else if(!(this.ptr instanceof b.Reflect.Message.OneOf||this.ptr instanceof b.Reflect.Extension||this.ptr instanceof b.Reflect.Enum.Value))throw Error("illegal object in namespace: "+
typeof this.ptr+": "+this.ptr);return this.reset()};k.build=function(a){this.reset();this.resolved||(this.resolveAll(),this.resolved=!0,this.result=null);null===this.result&&(this.result=this.ns.build());if(!a)return this.result;a="string"===typeof a?a.split("."):a;for(var b=this.result,d=0;d<a.length;d++)if(b[a[d]])b=b[a[d]];else{b=null;break}return b};k.lookup=function(a,b){return a?this.ns.resolve(a,b):this.ns};k.toString=function(){return"Builder"};n.Message=function(){};n.Enum=function(){};n.Service=
function(){};return n}(d,d.Lang,d.Reflect);d.Map=function(b,d){function h(b){var a=0;return{next:function(){return a<b.length?{done:!1,value:b[a++]}:{done:!0}}}}var q=function(b,a){if(!b.map)throw Error("field is not a map");this.field=b;this.keyElem=new d.Element(b.keyType,null,!0,b.syntax);this.valueElem=new d.Element(b.type,b.resolvedType,!1,b.syntax);this.map={};Object.defineProperty(this,"size",{get:function(){return Object.keys(this.map).length}});if(a)for(var e=Object.keys(a),g=0;g<e.length;g++){var h=
this.keyElem.valueFromString(e[g]),c=this.valueElem.verifyValue(a[e[g]]);this.map[this.keyElem.valueToString(h)]={key:h,value:c}}},n=q.prototype;n.clear=function(){this.map={}};n["delete"]=function(b){b=this.keyElem.valueToString(this.keyElem.verifyValue(b));var a=b in this.map;delete this.map[b];return a};n.entries=function(){for(var b=[],a=Object.keys(this.map),d=0,g;d<a.length;d++)b.push([(g=this.map[a[d]]).key,g.value]);return h(b)};n.keys=function(){for(var b=[],a=Object.keys(this.map),d=0;d<
a.length;d++)b.push(this.map[a[d]].key);return h(b)};n.values=function(){for(var b=[],a=Object.keys(this.map),d=0;d<a.length;d++)b.push(this.map[a[d]].value);return h(b)};n.forEach=function(b,a){for(var d=Object.keys(this.map),g=0,h;g<d.length;g++)b.call(a,(h=this.map[d[g]]).value,h.key,this)};n.set=function(b,a){var d=this.keyElem.verifyValue(b),g=this.valueElem.verifyValue(a);this.map[this.keyElem.valueToString(d)]={key:d,value:g};return this};n.get=function(b){b=this.keyElem.valueToString(this.keyElem.verifyValue(b));
return b in this.map?this.map[b].value:void 0};n.has=function(b){return this.keyElem.valueToString(this.keyElem.verifyValue(b))in this.map};return q}(d,d.Reflect);d.loadProto=function(b,h,p){if("string"===typeof h||h&&"string"===typeof h.file&&"string"===typeof h.root)p=h,h=void 0;return d.loadJson(d.DotProto.Parser.parse(b),h,p)};d.protoFromString=d.loadProto;d.loadProtoFile=function(b,h,p){h&&"object"===typeof h?(p=h,h=null):h&&"function"===typeof h||(h=null);if(h)return d.Util.fetch("string"===
typeof b?b:b.root+"/"+b.file,function(n){if(null===n)h(Error("Failed to fetch file"));else try{h(null,d.loadProto(n,p,b))}catch(k){h(k)}});var q=d.Util.fetch("object"===typeof b?b.root+"/"+b.file:b);return null===q?null:d.loadProto(q,p,b)};d.protoFromFile=d.loadProtoFile;d.newBuilder=function(b){b=b||{};"undefined"===typeof b.convertFieldsToCamelCase&&(b.convertFieldsToCamelCase=d.convertFieldsToCamelCase);"undefined"===typeof b.populateAccessors&&(b.populateAccessors=d.populateAccessors);return new d.Builder(b)};
d.loadJson=function(b,h,p){if("string"===typeof h||h&&"string"===typeof h.file&&"string"===typeof h.root)p=h,h=null;h&&"object"===typeof h||(h=d.newBuilder());"string"===typeof b&&(b=JSON.parse(b));h["import"](b,p);h.resolveAll();return h};d.loadJsonFile=function(b,h,p){h&&"object"===typeof h?(p=h,h=null):h&&"function"===typeof h||(h=null);if(h)return d.Util.fetch("string"===typeof b?b:b.root+"/"+b.file,function(n){if(null===n)h(Error("Failed to fetch file"));else try{h(null,d.loadJson(JSON.parse(n),
p,b))}catch(k){h(k)}});var q=d.Util.fetch("object"===typeof b?b.root+"/"+b.file:b);return null===q?null:d.loadJson(JSON.parse(q),p,b)};return d});
